searchData={"items":[{"type":"module","title":"OpenaiEx","doc":"`OpenaiEx` is an Elixir library that provides a community-maintained client for\nthe OpenAI API.\n\nThe library closely follows the structure of the [official OpenAI API client libraries](https://platform.openai.com/docs/api-reference)\nfor [Python](https://github.com/openai/openai-python) making it easy to understand\nand reuse existing documentation and code.","ref":"OpenaiEx.html"},{"type":"function","title":"OpenaiEx.new/3","doc":"Creates a new OpenaiEx struct with the specified token and organization.\n\nSee https://platform.openai.com/docs/api-reference/authentication for details.","ref":"OpenaiEx.html#new/3"},{"type":"function","title":"OpenaiEx.new_file/1","doc":"Create file parameter struct for use in multipart requests.\n\nOpenAI API has endpoints which need a file parameter, such as Files and Audio.\nThis function creates a file parameter given a name (optional) and content or a local file path.","ref":"OpenaiEx.html#new_file/1"},{"type":"function","title":"OpenaiEx.with_additional_headers/2","doc":"","ref":"OpenaiEx.html#with_additional_headers/2"},{"type":"function","title":"OpenaiEx.with_base_url/2","doc":"","ref":"OpenaiEx.html#with_base_url/2"},{"type":"function","title":"OpenaiEx.with_finch_name/2","doc":"","ref":"OpenaiEx.html#with_finch_name/2"},{"type":"function","title":"OpenaiEx.with_receive_timeout/2","doc":"","ref":"OpenaiEx.html#with_receive_timeout/2"},{"type":"function","title":"OpenaiEx.with_stream_timeout/2","doc":"","ref":"OpenaiEx.html#with_stream_timeout/2"},{"type":"module","title":"OpenaiEx.Audio.Speech","doc":"This module provides an implementation of the OpenAI audio speech API. The API reference can be found at https://platform.openai.com/docs/api-reference/audio/createSpeech.","ref":"OpenaiEx.Audio.Speech.html"},{"type":"function","title":"OpenaiEx.Audio.Speech.create/2","doc":"","ref":"OpenaiEx.Audio.Speech.html#create/2"},{"type":"function","title":"OpenaiEx.Audio.Speech.create!/2","doc":"Calls the audio speech endpoint.\n\nSee https://platform.openai.com/docs/api-reference/audio/createSpeech for more information.","ref":"OpenaiEx.Audio.Speech.html#create!/2"},{"type":"function","title":"OpenaiEx.Audio.Speech.new/1","doc":"Creates a new audio speech request","ref":"OpenaiEx.Audio.Speech.html#new/1"},{"type":"module","title":"OpenaiEx.Audio.Transcription","doc":"This module provides an implementation of the OpenAI audio transcription API. The API reference can be found at https://platform.openai.com/docs/api-reference/audio/createTranscription.","ref":"OpenaiEx.Audio.Transcription.html"},{"type":"function","title":"OpenaiEx.Audio.Transcription.create/2","doc":"","ref":"OpenaiEx.Audio.Transcription.html#create/2"},{"type":"function","title":"OpenaiEx.Audio.Transcription.create!/2","doc":"Calls the audio transcription endpoint.\n\nSee https://platform.openai.com/docs/api-reference/audio/createTranscription for more information.","ref":"OpenaiEx.Audio.Transcription.html#create!/2"},{"type":"function","title":"OpenaiEx.Audio.Transcription.new/1","doc":"Creates a new audio request with the given arguments.","ref":"OpenaiEx.Audio.Transcription.html#new/1"},{"type":"module","title":"OpenaiEx.Audio.Translation","doc":"This module provides an implementation of the OpenAI audio translation API. The API reference can be found at https://platform.openai.com/docs/api-reference/audio/createTranslation.","ref":"OpenaiEx.Audio.Translation.html"},{"type":"function","title":"OpenaiEx.Audio.Translation.create/2","doc":"","ref":"OpenaiEx.Audio.Translation.html#create/2"},{"type":"function","title":"OpenaiEx.Audio.Translation.create!/2","doc":"Calls the audio translation endpoint.\n\nSee https://platform.openai.com/docs/api-reference/audio/createTranslation for more information.","ref":"OpenaiEx.Audio.Translation.html#create!/2"},{"type":"function","title":"OpenaiEx.Audio.Translation.new/1","doc":"Creates a new audio translation request","ref":"OpenaiEx.Audio.Translation.html#new/1"},{"type":"module","title":"OpenaiEx.Batches","doc":"This module provides an implementation of the OpenAI Batch API. The API reference can be found at https://platform.openai.com/docs/api-reference/batch.","ref":"OpenaiEx.Batches.html"},{"type":"function","title":"OpenaiEx.Batches.cancel/2","doc":"","ref":"OpenaiEx.Batches.html#cancel/2"},{"type":"function","title":"OpenaiEx.Batches.cancel!/2","doc":"Cancels an in-progress batch.\n\nhttps://platform.openai.com/docs/api-reference/batch/cancel","ref":"OpenaiEx.Batches.html#cancel!/2"},{"type":"function","title":"OpenaiEx.Batches.create/2","doc":"","ref":"OpenaiEx.Batches.html#create/2"},{"type":"function","title":"OpenaiEx.Batches.create!/2","doc":"Creates and executes a batch from an uploaded file of requests.\n\nhttps://platform.openai.com/docs/api-reference/batch/create","ref":"OpenaiEx.Batches.html#create!/2"},{"type":"function","title":"OpenaiEx.Batches.list/2","doc":"","ref":"OpenaiEx.Batches.html#list/2"},{"type":"function","title":"OpenaiEx.Batches.list!/2","doc":"Lists your organization's batches.\n\nhttps://platform.openai.com/docs/api-reference/batch/list","ref":"OpenaiEx.Batches.html#list!/2"},{"type":"function","title":"OpenaiEx.Batches.new/1","doc":"Creates a new batch request","ref":"OpenaiEx.Batches.html#new/1"},{"type":"function","title":"OpenaiEx.Batches.retrieve/2","doc":"","ref":"OpenaiEx.Batches.html#retrieve/2"},{"type":"function","title":"OpenaiEx.Batches.retrieve!/2","doc":"Retrieves a batch.\n\nhttps://platform.openai.com/docs/api-reference/batch/retrieve","ref":"OpenaiEx.Batches.html#retrieve!/2"},{"type":"module","title":"OpenaiEx.Beta.Assistants","doc":"This module provides an implementation of the OpenAI assistants API. The API reference can be found at https://platform.openai.com/docs/api-reference/assistants.","ref":"OpenaiEx.Beta.Assistants.html"},{"type":"function","title":"OpenaiEx.Beta.Assistants.create/2","doc":"","ref":"OpenaiEx.Beta.Assistants.html#create/2"},{"type":"function","title":"OpenaiEx.Beta.Assistants.create!/2","doc":"Calls the assistant 'create' endpoint.\n\nSee https://platform.openai.com/docs/api-reference/assistants/createAssistant for more information.","ref":"OpenaiEx.Beta.Assistants.html#create!/2"},{"type":"function","title":"OpenaiEx.Beta.Assistants.delete/2","doc":"","ref":"OpenaiEx.Beta.Assistants.html#delete/2"},{"type":"function","title":"OpenaiEx.Beta.Assistants.delete!/2","doc":"Calls the assistant delete endpoint.\n\nhttps://platform.openai.com/docs/api-reference/assistants/deleteAssistant","ref":"OpenaiEx.Beta.Assistants.html#delete!/2"},{"type":"function","title":"OpenaiEx.Beta.Assistants.list/2","doc":"","ref":"OpenaiEx.Beta.Assistants.html#list/2"},{"type":"function","title":"OpenaiEx.Beta.Assistants.list!/2","doc":"Returns a list of assistant objects.\n\nhttps://platform.openai.com/docs/api-reference/assistants/listAssistants","ref":"OpenaiEx.Beta.Assistants.html#list!/2"},{"type":"function","title":"OpenaiEx.Beta.Assistants.new/1","doc":"Creates a new assistants request\n\nExample usage:\n\n    iex> _request = OpenaiEx.Beta.Assistants.new(model: \"gpt-4-turbo\")\n    %{model: \"gpt-4-turbo\"}","ref":"OpenaiEx.Beta.Assistants.html#new/1"},{"type":"function","title":"OpenaiEx.Beta.Assistants.new_list/1","doc":"Creates a new list assistants request","ref":"OpenaiEx.Beta.Assistants.html#new_list/1"},{"type":"function","title":"OpenaiEx.Beta.Assistants.retrieve/2","doc":"","ref":"OpenaiEx.Beta.Assistants.html#retrieve/2"},{"type":"function","title":"OpenaiEx.Beta.Assistants.retrieve!/2","doc":"Calls the assistant retrieve endpoint.\n\nhttps://platform.openai.com/docs/api-reference/assistants/getAssistant","ref":"OpenaiEx.Beta.Assistants.html#retrieve!/2"},{"type":"function","title":"OpenaiEx.Beta.Assistants.update/3","doc":"","ref":"OpenaiEx.Beta.Assistants.html#update/3"},{"type":"function","title":"OpenaiEx.Beta.Assistants.update!/3","doc":"Calls the assistant update endpoint.\n\nSee https://platform.openai.com/docs/api-reference/assistants/modifyAssistant for more information.","ref":"OpenaiEx.Beta.Assistants.html#update!/3"},{"type":"module","title":"OpenaiEx.Beta.Threads","doc":"This module provides an implementation of the OpenAI threads API. The API reference can be found at https://platform.openai.com/docs/api-reference/threads.","ref":"OpenaiEx.Beta.Threads.html"},{"type":"function","title":"OpenaiEx.Beta.Threads.create/2","doc":"","ref":"OpenaiEx.Beta.Threads.html#create/2"},{"type":"function","title":"OpenaiEx.Beta.Threads.create!/2","doc":"Calls the thread create endpoint.\n\nhttps://platform.openai.com/docs/api-reference/threads/createThread","ref":"OpenaiEx.Beta.Threads.html#create!/2"},{"type":"function","title":"OpenaiEx.Beta.Threads.delete/2","doc":"","ref":"OpenaiEx.Beta.Threads.html#delete/2"},{"type":"function","title":"OpenaiEx.Beta.Threads.delete!/2","doc":"Calls the thread delete endpoint.\n\nhttps://platform.openai.com/docs/api-reference/threads/deleteThread","ref":"OpenaiEx.Beta.Threads.html#delete!/2"},{"type":"function","title":"OpenaiEx.Beta.Threads.list/2","doc":"","ref":"OpenaiEx.Beta.Threads.html#list/2"},{"type":"function","title":"OpenaiEx.Beta.Threads.new/1","doc":"Creates a new threads request","ref":"OpenaiEx.Beta.Threads.html#new/1"},{"type":"function","title":"OpenaiEx.Beta.Threads.retrieve/2","doc":"","ref":"OpenaiEx.Beta.Threads.html#retrieve/2"},{"type":"function","title":"OpenaiEx.Beta.Threads.retrieve!/2","doc":"Calls the thread retrieve endpoint.\n\nhttps://platform.openai.com/docs/api-reference/threads/getThread","ref":"OpenaiEx.Beta.Threads.html#retrieve!/2"},{"type":"function","title":"OpenaiEx.Beta.Threads.update/3","doc":"","ref":"OpenaiEx.Beta.Threads.html#update/3"},{"type":"function","title":"OpenaiEx.Beta.Threads.update!/3","doc":"Calls the thread update endpoint.\n\nhttps://platform.openai.com/docs/api-reference/threads/modifyThread","ref":"OpenaiEx.Beta.Threads.html#update!/3"},{"type":"module","title":"OpenaiEx.Beta.Threads.Messages","doc":"This module provides an implementation of the OpenAI messages API. The API\nreference can be found at https://platform.openai.com/docs/api-reference/messages.","ref":"OpenaiEx.Beta.Threads.Messages.html"},{"type":"function","title":"OpenaiEx.Beta.Threads.Messages.create/3","doc":"","ref":"OpenaiEx.Beta.Threads.Messages.html#create/3"},{"type":"function","title":"OpenaiEx.Beta.Threads.Messages.create!/3","doc":"Calls the message create endpoint.\n\nhttps://platform.openai.com/docs/api-reference/messages/createMessage","ref":"OpenaiEx.Beta.Threads.Messages.html#create!/3"},{"type":"function","title":"OpenaiEx.Beta.Threads.Messages.delete/3","doc":"","ref":"OpenaiEx.Beta.Threads.Messages.html#delete/3"},{"type":"function","title":"OpenaiEx.Beta.Threads.Messages.delete!/3","doc":"","ref":"OpenaiEx.Beta.Threads.Messages.html#delete!/3"},{"type":"function","title":"OpenaiEx.Beta.Threads.Messages.list/3","doc":"","ref":"OpenaiEx.Beta.Threads.Messages.html#list/3"},{"type":"function","title":"OpenaiEx.Beta.Threads.Messages.list!/3","doc":"","ref":"OpenaiEx.Beta.Threads.Messages.html#list!/3"},{"type":"function","title":"OpenaiEx.Beta.Threads.Messages.new/1","doc":"Creates a new message request","ref":"OpenaiEx.Beta.Threads.Messages.html#new/1"},{"type":"function","title":"OpenaiEx.Beta.Threads.Messages.new_list/1","doc":"Lists the messages that belong to the specified thread.\n\nhttps://platform.openai.com/docs/api-reference/messages/listMessages","ref":"OpenaiEx.Beta.Threads.Messages.html#new_list/1"},{"type":"function","title":"OpenaiEx.Beta.Threads.Messages.retrieve/2","doc":"","ref":"OpenaiEx.Beta.Threads.Messages.html#retrieve/2"},{"type":"function","title":"OpenaiEx.Beta.Threads.Messages.retrieve!/2","doc":"Calls the message retrieve endpoint.\n\nhttps://platform.openai.com/docs/api-reference/messages/getMessage","ref":"OpenaiEx.Beta.Threads.Messages.html#retrieve!/2"},{"type":"function","title":"OpenaiEx.Beta.Threads.Messages.update/2","doc":"","ref":"OpenaiEx.Beta.Threads.Messages.html#update/2"},{"type":"function","title":"OpenaiEx.Beta.Threads.Messages.update!/2","doc":"Calls the message update endpoint.\n\nhttps://platform.openai.com/docs/api-reference/messages/modifyMessage","ref":"OpenaiEx.Beta.Threads.Messages.html#update!/2"},{"type":"module","title":"OpenaiEx.Beta.Threads.Runs","doc":"This module provides an implementation of the OpenAI run API. The API\nreference can be found at https://platform.openai.com/docs/api-reference/runs.","ref":"OpenaiEx.Beta.Threads.Runs.html"},{"type":"function","title":"OpenaiEx.Beta.Threads.Runs.cancel/2","doc":"","ref":"OpenaiEx.Beta.Threads.Runs.html#cancel/2"},{"type":"function","title":"OpenaiEx.Beta.Threads.Runs.cancel!/2","doc":"","ref":"OpenaiEx.Beta.Threads.Runs.html#cancel!/2"},{"type":"function","title":"OpenaiEx.Beta.Threads.Runs.create/2","doc":"","ref":"OpenaiEx.Beta.Threads.Runs.html#create/2"},{"type":"function","title":"OpenaiEx.Beta.Threads.Runs.create/3","doc":"","ref":"OpenaiEx.Beta.Threads.Runs.html#create/3"},{"type":"function","title":"OpenaiEx.Beta.Threads.Runs.create!/2","doc":"","ref":"OpenaiEx.Beta.Threads.Runs.html#create!/2"},{"type":"function","title":"OpenaiEx.Beta.Threads.Runs.create!/3","doc":"Calls the run create endpoint.\n\nSee https://platform.openai.com/docs/api-reference/runs/createRun for more information.","ref":"OpenaiEx.Beta.Threads.Runs.html#create!/3"},{"type":"function","title":"OpenaiEx.Beta.Threads.Runs.create_and_run/2","doc":"","ref":"OpenaiEx.Beta.Threads.Runs.html#create_and_run/2"},{"type":"function","title":"OpenaiEx.Beta.Threads.Runs.create_and_run/3","doc":"","ref":"OpenaiEx.Beta.Threads.Runs.html#create_and_run/3"},{"type":"function","title":"OpenaiEx.Beta.Threads.Runs.create_and_run!/2","doc":"","ref":"OpenaiEx.Beta.Threads.Runs.html#create_and_run!/2"},{"type":"function","title":"OpenaiEx.Beta.Threads.Runs.create_and_run!/3","doc":"","ref":"OpenaiEx.Beta.Threads.Runs.html#create_and_run!/3"},{"type":"function","title":"OpenaiEx.Beta.Threads.Runs.list/2","doc":"","ref":"OpenaiEx.Beta.Threads.Runs.html#list/2"},{"type":"function","title":"OpenaiEx.Beta.Threads.Runs.list!/2","doc":"Returns a list of runs objects.\n\nhttps://platform.openai.com/docs/api-reference/runs/listRuns","ref":"OpenaiEx.Beta.Threads.Runs.html#list!/2"},{"type":"function","title":"OpenaiEx.Beta.Threads.Runs.new/1","doc":"Creates a new run request\n\nExample usage:\n\n    iex> _request = OpenaiEx.Beta.Threads.Runs.new(thread_id: \"thread_foo\", assistant_id: \"assistant_bar\")\n    %{assistant_id: \"assistant_bar\", thread_id: \"thread_foo\"}","ref":"OpenaiEx.Beta.Threads.Runs.html#new/1"},{"type":"function","title":"OpenaiEx.Beta.Threads.Runs.new_list/1","doc":"Creates a new list runs request","ref":"OpenaiEx.Beta.Threads.Runs.html#new_list/1"},{"type":"function","title":"OpenaiEx.Beta.Threads.Runs.retrieve/2","doc":"","ref":"OpenaiEx.Beta.Threads.Runs.html#retrieve/2"},{"type":"function","title":"OpenaiEx.Beta.Threads.Runs.retrieve!/2","doc":"Calls the run retrieve endpoint.\n\nhttps://platform.openai.com/docs/api-reference/runs/getRun","ref":"OpenaiEx.Beta.Threads.Runs.html#retrieve!/2"},{"type":"function","title":"OpenaiEx.Beta.Threads.Runs.submit_tool_outputs/2","doc":"","ref":"OpenaiEx.Beta.Threads.Runs.html#submit_tool_outputs/2"},{"type":"function","title":"OpenaiEx.Beta.Threads.Runs.submit_tool_outputs/3","doc":"","ref":"OpenaiEx.Beta.Threads.Runs.html#submit_tool_outputs/3"},{"type":"function","title":"OpenaiEx.Beta.Threads.Runs.submit_tool_outputs!/2","doc":"","ref":"OpenaiEx.Beta.Threads.Runs.html#submit_tool_outputs!/2"},{"type":"function","title":"OpenaiEx.Beta.Threads.Runs.submit_tool_outputs!/3","doc":"","ref":"OpenaiEx.Beta.Threads.Runs.html#submit_tool_outputs!/3"},{"type":"function","title":"OpenaiEx.Beta.Threads.Runs.update/2","doc":"","ref":"OpenaiEx.Beta.Threads.Runs.html#update/2"},{"type":"function","title":"OpenaiEx.Beta.Threads.Runs.update!/2","doc":"Calls the run update endpoint.\n\nSee https://platform.openai.com/docs/api-reference/assistants/modifyAssistant for more information.","ref":"OpenaiEx.Beta.Threads.Runs.html#update!/2"},{"type":"module","title":"OpenaiEx.Beta.Threads.Runs.Steps","doc":"This module provides an implementation of the OpenAI run steps API. The API reference can be found at https://platform.openai.com/docs/api-reference/run-steps.","ref":"OpenaiEx.Beta.Threads.Runs.Steps.html"},{"type":"function","title":"OpenaiEx.Beta.Threads.Runs.Steps.list/2","doc":"","ref":"OpenaiEx.Beta.Threads.Runs.Steps.html#list/2"},{"type":"function","title":"OpenaiEx.Beta.Threads.Runs.Steps.list!/2","doc":"","ref":"OpenaiEx.Beta.Threads.Runs.Steps.html#list!/2"},{"type":"function","title":"OpenaiEx.Beta.Threads.Runs.Steps.retrieve/2","doc":"","ref":"OpenaiEx.Beta.Threads.Runs.Steps.html#retrieve/2"},{"type":"function","title":"OpenaiEx.Beta.Threads.Runs.Steps.retrieve!/2","doc":"","ref":"OpenaiEx.Beta.Threads.Runs.Steps.html#retrieve!/2"},{"type":"module","title":"OpenaiEx.Beta.VectorStores","doc":"This module provides an implementation of the OpenAI vector_stores API. The API reference can be found at https://platform.openai.com/docs/api-reference/vector-stores.","ref":"OpenaiEx.Beta.VectorStores.html"},{"type":"function","title":"OpenaiEx.Beta.VectorStores.create/2","doc":"","ref":"OpenaiEx.Beta.VectorStores.html#create/2"},{"type":"function","title":"OpenaiEx.Beta.VectorStores.create!/2","doc":"","ref":"OpenaiEx.Beta.VectorStores.html#create!/2"},{"type":"function","title":"OpenaiEx.Beta.VectorStores.delete/2","doc":"","ref":"OpenaiEx.Beta.VectorStores.html#delete/2"},{"type":"function","title":"OpenaiEx.Beta.VectorStores.delete!/2","doc":"","ref":"OpenaiEx.Beta.VectorStores.html#delete!/2"},{"type":"function","title":"OpenaiEx.Beta.VectorStores.list/1","doc":"","ref":"OpenaiEx.Beta.VectorStores.html#list/1"},{"type":"function","title":"OpenaiEx.Beta.VectorStores.list!/1","doc":"","ref":"OpenaiEx.Beta.VectorStores.html#list!/1"},{"type":"function","title":"OpenaiEx.Beta.VectorStores.new/1","doc":"","ref":"OpenaiEx.Beta.VectorStores.html#new/1"},{"type":"function","title":"OpenaiEx.Beta.VectorStores.retrieve/2","doc":"","ref":"OpenaiEx.Beta.VectorStores.html#retrieve/2"},{"type":"function","title":"OpenaiEx.Beta.VectorStores.retrieve!/2","doc":"","ref":"OpenaiEx.Beta.VectorStores.html#retrieve!/2"},{"type":"function","title":"OpenaiEx.Beta.VectorStores.update/3","doc":"","ref":"OpenaiEx.Beta.VectorStores.html#update/3"},{"type":"function","title":"OpenaiEx.Beta.VectorStores.update!/3","doc":"","ref":"OpenaiEx.Beta.VectorStores.html#update!/3"},{"type":"module","title":"OpenaiEx.Beta.VectorStores.File.Batches","doc":"This module provides an implementation of the OpenAI vector_store file batches API. The API reference can be found at https://platform.openai.com/docs/api-reference/vector-stores-file-batches.","ref":"OpenaiEx.Beta.VectorStores.File.Batches.html"},{"type":"function","title":"OpenaiEx.Beta.VectorStores.File.Batches.cancel/3","doc":"","ref":"OpenaiEx.Beta.VectorStores.File.Batches.html#cancel/3"},{"type":"function","title":"OpenaiEx.Beta.VectorStores.File.Batches.cancel!/3","doc":"","ref":"OpenaiEx.Beta.VectorStores.File.Batches.html#cancel!/3"},{"type":"function","title":"OpenaiEx.Beta.VectorStores.File.Batches.create/3","doc":"","ref":"OpenaiEx.Beta.VectorStores.File.Batches.html#create/3"},{"type":"function","title":"OpenaiEx.Beta.VectorStores.File.Batches.create!/3","doc":"","ref":"OpenaiEx.Beta.VectorStores.File.Batches.html#create!/3"},{"type":"function","title":"OpenaiEx.Beta.VectorStores.File.Batches.list/4","doc":"","ref":"OpenaiEx.Beta.VectorStores.File.Batches.html#list/4"},{"type":"function","title":"OpenaiEx.Beta.VectorStores.File.Batches.list!/4","doc":"","ref":"OpenaiEx.Beta.VectorStores.File.Batches.html#list!/4"},{"type":"function","title":"OpenaiEx.Beta.VectorStores.File.Batches.retrieve/3","doc":"","ref":"OpenaiEx.Beta.VectorStores.File.Batches.html#retrieve/3"},{"type":"function","title":"OpenaiEx.Beta.VectorStores.File.Batches.retrieve!/3","doc":"","ref":"OpenaiEx.Beta.VectorStores.File.Batches.html#retrieve!/3"},{"type":"module","title":"OpenaiEx.Beta.VectorStores.Files","doc":"This module provides an implementation of the OpenAI vector_store files API. The API reference can be found at https://platform.openai.com/docs/api-reference/vector-stores-files.","ref":"OpenaiEx.Beta.VectorStores.Files.html"},{"type":"function","title":"OpenaiEx.Beta.VectorStores.Files.create/3","doc":"","ref":"OpenaiEx.Beta.VectorStores.Files.html#create/3"},{"type":"function","title":"OpenaiEx.Beta.VectorStores.Files.create!/3","doc":"","ref":"OpenaiEx.Beta.VectorStores.Files.html#create!/3"},{"type":"function","title":"OpenaiEx.Beta.VectorStores.Files.delete/3","doc":"","ref":"OpenaiEx.Beta.VectorStores.Files.html#delete/3"},{"type":"function","title":"OpenaiEx.Beta.VectorStores.Files.delete!/3","doc":"","ref":"OpenaiEx.Beta.VectorStores.Files.html#delete!/3"},{"type":"function","title":"OpenaiEx.Beta.VectorStores.Files.list/3","doc":"","ref":"OpenaiEx.Beta.VectorStores.Files.html#list/3"},{"type":"function","title":"OpenaiEx.Beta.VectorStores.Files.list!/3","doc":"","ref":"OpenaiEx.Beta.VectorStores.Files.html#list!/3"},{"type":"function","title":"OpenaiEx.Beta.VectorStores.Files.retrieve/3","doc":"","ref":"OpenaiEx.Beta.VectorStores.Files.html#retrieve/3"},{"type":"function","title":"OpenaiEx.Beta.VectorStores.Files.retrieve!/3","doc":"","ref":"OpenaiEx.Beta.VectorStores.Files.html#retrieve!/3"},{"type":"module","title":"OpenaiEx.Chat.Completions","doc":"This module provides an implementation of the OpenAI chat completions API. The API reference can be found at https://platform.openai.com/docs/api-reference/chat/completions.","ref":"OpenaiEx.Chat.Completions.html"},{"type":"function","title":"OpenaiEx.Chat.Completions.create/2","doc":"","ref":"OpenaiEx.Chat.Completions.html#create/2"},{"type":"function","title":"OpenaiEx.Chat.Completions.create/3","doc":"","ref":"OpenaiEx.Chat.Completions.html#create/3"},{"type":"function","title":"OpenaiEx.Chat.Completions.create!/2","doc":"","ref":"OpenaiEx.Chat.Completions.html#create!/2"},{"type":"function","title":"OpenaiEx.Chat.Completions.create!/3","doc":"Calls the chat completion 'create' endpoint.\n\nSee https://platform.openai.com/docs/api-reference/chat/completions/create for more information.","ref":"OpenaiEx.Chat.Completions.html#create!/3"},{"type":"function","title":"OpenaiEx.Chat.Completions.delete/2","doc":"","ref":"OpenaiEx.Chat.Completions.html#delete/2"},{"type":"function","title":"OpenaiEx.Chat.Completions.delete!/2","doc":"Deletes a stored chat completion.\n\nSee https://platform.openai.com/docs/api-reference/chat/delete","ref":"OpenaiEx.Chat.Completions.html#delete!/2"},{"type":"function","title":"OpenaiEx.Chat.Completions.list/2","doc":"","ref":"OpenaiEx.Chat.Completions.html#list/2"},{"type":"function","title":"OpenaiEx.Chat.Completions.list!/2","doc":"Lists stored Chat Completions.\n\nSee https://platform.openai.com/docs/api-reference/chat/list","ref":"OpenaiEx.Chat.Completions.html#list!/2"},{"type":"function","title":"OpenaiEx.Chat.Completions.messages_list/3","doc":"","ref":"OpenaiEx.Chat.Completions.html#messages_list/3"},{"type":"function","title":"OpenaiEx.Chat.Completions.messages_list!/3","doc":"Lists messages from a stored chat completion.\n\nSee https://platform.openai.com/docs/api-reference/chat/getMessages","ref":"OpenaiEx.Chat.Completions.html#messages_list!/3"},{"type":"function","title":"OpenaiEx.Chat.Completions.new/1","doc":"Creates a new chat completion request\n\nExample usage:\n\n    iex> _request = OpenaiEx.Chat.Completions.new(model: \"davinci\", messages: [OpenaiEx.ChatMessage.user(\"Hello, world!\")])\n    %{messages: [%{content: \"Hello, world!\", role: \"user\"}], model: \"davinci\"}\n\n    iex> _request = OpenaiEx.Chat.Completions.new(%{model: \"davinci\", messages: [OpenaiEx.ChatMessage.user(\"Hello, world!\")]})\n    %{messages: [%{content: \"Hello, world!\", role: \"user\"}], model: \"davinci\"}","ref":"OpenaiEx.Chat.Completions.html#new/1"},{"type":"function","title":"OpenaiEx.Chat.Completions.retrieve/2","doc":"","ref":"OpenaiEx.Chat.Completions.html#retrieve/2"},{"type":"function","title":"OpenaiEx.Chat.Completions.retrieve!/2","doc":"Retrieves a stored chat completion by ID.\n\nSee https://platform.openai.com/docs/api-reference/chat/get","ref":"OpenaiEx.Chat.Completions.html#retrieve!/2"},{"type":"function","title":"OpenaiEx.Chat.Completions.update/2","doc":"","ref":"OpenaiEx.Chat.Completions.html#update/2"},{"type":"function","title":"OpenaiEx.Chat.Completions.update!/2","doc":"Updates a stored chat completion.\n\nSee https://platform.openai.com/docs/api-reference/chat/update","ref":"OpenaiEx.Chat.Completions.html#update!/2"},{"type":"module","title":"OpenaiEx.ChatMessage","doc":"This module provides an elixir map wrapper around the OpenAI message JSON\nobject which is used in the chat completions and assistants APIs.","ref":"OpenaiEx.ChatMessage.html"},{"type":"function","title":"OpenaiEx.ChatMessage.assistant/1","doc":"Create a `ChatMessage` map with role `assistant`.\n\nExample usage:\n\n    iex> _message = OpenaiEx.ChatMessage.assistant(\"Hello, world!\")\n    %{content: \"Hello, world!\", role: \"assistant\"}","ref":"OpenaiEx.ChatMessage.html#assistant/1"},{"type":"function","title":"OpenaiEx.ChatMessage.developer/1","doc":"Create a `ChatMessage` map with role `developer`.\n\nExample usage:\n\n    iex> _message = OpenaiEx.ChatMessage.developer(\"Hello, world!\")\n    %{content: \"Hello, world!\", role: \"developer\"}","ref":"OpenaiEx.ChatMessage.html#developer/1"},{"type":"function","title":"OpenaiEx.ChatMessage.system/1","doc":"Create a `ChatMessage` map with role `system`.\n\nExample usage:\n\n    iex> _message = OpenaiEx.ChatMessage.system(\"Hello, world!\")\n    %{content: \"Hello, world!\", role: \"system\"}","ref":"OpenaiEx.ChatMessage.html#system/1"},{"type":"function","title":"OpenaiEx.ChatMessage.tool/3","doc":"Create a `ChatMessage` map with role `function`.\n\nExample usage:\n\n    iex> _message = OpenaiEx.ChatMessage.tool(\"call_sjflkje\", \"greet\", \"Hello, world!\")\n    %{content: \"Hello, world!\", role: \"tool\", name: \"greet\", tool_call_id: \"call_sjflkje\"}","ref":"OpenaiEx.ChatMessage.html#tool/3"},{"type":"function","title":"OpenaiEx.ChatMessage.user/1","doc":"Create a `ChatMessage` map with role `user`.\n\nExample usage:\n\n    iex> _message = OpenaiEx.ChatMessage.user(\"Hello, world!\")\n    %{content: \"Hello, world!\", role: \"user\"}","ref":"OpenaiEx.ChatMessage.html#user/1"},{"type":"module","title":"OpenaiEx.Completion","doc":"This module provides an implementation of the OpenAI completions API. The API reference can be found at https://platform.openai.com/docs/api-reference/completions.","ref":"OpenaiEx.Completion.html"},{"type":"function","title":"OpenaiEx.Completion.create/2","doc":"","ref":"OpenaiEx.Completion.html#create/2"},{"type":"function","title":"OpenaiEx.Completion.create/3","doc":"","ref":"OpenaiEx.Completion.html#create/3"},{"type":"function","title":"OpenaiEx.Completion.create!/2","doc":"","ref":"OpenaiEx.Completion.html#create!/2"},{"type":"function","title":"OpenaiEx.Completion.create!/3","doc":"Calls the completion 'create' endpoint.\n\nSee https://platform.openai.com/docs/api-reference/completions/create for more information.","ref":"OpenaiEx.Completion.html#create!/3"},{"type":"function","title":"OpenaiEx.Completion.new/1","doc":"Creates a new completion request with the given arguments.\n\nExample usage:\n    iex> _request = OpenaiEx.Completion.new(model: \"davinci\")\n    %{model: \"davinci\"}\n    iex> _request = OpenaiEx.Completion.new(%{model: \"davinci\"})\n    %{model: \"davinci\"}","ref":"OpenaiEx.Completion.html#new/1"},{"type":"module","title":"OpenaiEx.Embeddings","doc":"This module provides an implementation of the OpenAI embeddings API. The API reference can be found at https://platform.openai.com/docs/api-reference/embeddings.","ref":"OpenaiEx.Embeddings.html"},{"type":"function","title":"OpenaiEx.Embeddings.create/2","doc":"","ref":"OpenaiEx.Embeddings.html#create/2"},{"type":"function","title":"OpenaiEx.Embeddings.create!/2","doc":"Calls the embedding endpoint.\n\nSee https://platform.openai.com/docs/api-reference/embeddings/create for more information.","ref":"OpenaiEx.Embeddings.html#create!/2"},{"type":"function","title":"OpenaiEx.Embeddings.new/1","doc":"Creates a new embedding request\n\nExample usage:\n\n    iex> _request = OpenaiEx.Embeddings.new(model: \"text-embedding-ada-002\", input: \"This is a test\")\n    %{input: \"This is a test\", model: \"text-embedding-ada-002\"}\n\n    iex> _request = OpenaiEx.Embeddings.new(%{model: \"text-embedding-ada-002\", input: \"This is a test\"})\n    %{input: \"This is a test\", model: \"text-embedding-ada-002\"}","ref":"OpenaiEx.Embeddings.html#new/1"},{"type":"module","title":"OpenaiEx.Files","doc":"This module provides an implementation of the OpenAI files API. The API reference can be found at https://platform.openai.com/docs/api-reference/files.","ref":"OpenaiEx.Files.html"},{"type":"function","title":"OpenaiEx.Files.content/2","doc":"","ref":"OpenaiEx.Files.html#content/2"},{"type":"function","title":"OpenaiEx.Files.content!/2","doc":"Calls the file retrieve_content endpoint.\n\nhttps://platform.openai.com/docs/api-reference/files/retrieve-content","ref":"OpenaiEx.Files.html#content!/2"},{"type":"function","title":"OpenaiEx.Files.create/2","doc":"","ref":"OpenaiEx.Files.html#create/2"},{"type":"function","title":"OpenaiEx.Files.create!/2","doc":"Calls the file upload endpoint.\n\nhttps://platform.openai.com/docs/api-reference/files/upload","ref":"OpenaiEx.Files.html#create!/2"},{"type":"function","title":"OpenaiEx.Files.delete/2","doc":"","ref":"OpenaiEx.Files.html#delete/2"},{"type":"function","title":"OpenaiEx.Files.delete!/2","doc":"Calls the file delete endpoint.\n\nhttps://platform.openai.com/docs/api-reference/files/delete","ref":"OpenaiEx.Files.html#delete!/2"},{"type":"function","title":"OpenaiEx.Files.list/1","doc":"","ref":"OpenaiEx.Files.html#list/1"},{"type":"function","title":"OpenaiEx.Files.list!/1","doc":"Lists the files that belong to the user's organization.\n\nhttps://platform.openai.com/docs/api-reference/files/list","ref":"OpenaiEx.Files.html#list!/1"},{"type":"function","title":"OpenaiEx.Files.new/1","doc":"Creates a new file retrieve / deletion / retrieve_content request","ref":"OpenaiEx.Files.html#new/1"},{"type":"function","title":"OpenaiEx.Files.new_upload/1","doc":"Creates a new file upload request with the given arguments.","ref":"OpenaiEx.Files.html#new_upload/1"},{"type":"function","title":"OpenaiEx.Files.retrieve/2","doc":"","ref":"OpenaiEx.Files.html#retrieve/2"},{"type":"function","title":"OpenaiEx.Files.retrieve!/2","doc":"Calls the file retrieve endpoint.\n\nhttps://platform.openai.com/docs/api-reference/files/retrieve","ref":"OpenaiEx.Files.html#retrieve!/2"},{"type":"module","title":"OpenaiEx.FineTuning.Jobs","doc":"This module provides an implementation of the OpenAI fine-tuning job API. The API reference can be found at https://platform.openai.com/docs/api-reference/fine-tuning.","ref":"OpenaiEx.FineTuning.Jobs.html"},{"type":"function","title":"OpenaiEx.FineTuning.Jobs.cancel/2","doc":"","ref":"OpenaiEx.FineTuning.Jobs.html#cancel/2"},{"type":"function","title":"OpenaiEx.FineTuning.Jobs.cancel!/2","doc":"Calls the fine-tuning job cancel endpoint.\n\nhttps://platform.openai.com/docs/api-reference/fine-tuning/cancel","ref":"OpenaiEx.FineTuning.Jobs.html#cancel!/2"},{"type":"function","title":"OpenaiEx.FineTuning.Jobs.create/2","doc":"","ref":"OpenaiEx.FineTuning.Jobs.html#create/2"},{"type":"function","title":"OpenaiEx.FineTuning.Jobs.create!/2","doc":"Calls the fine-tuning job creation endpoint.\n\nhttps://platform.openai.com/docs/api-reference/fine-tuning/create","ref":"OpenaiEx.FineTuning.Jobs.html#create!/2"},{"type":"function","title":"OpenaiEx.FineTuning.Jobs.list/2","doc":"","ref":"OpenaiEx.FineTuning.Jobs.html#list/2"},{"type":"function","title":"OpenaiEx.FineTuning.Jobs.list!/2","doc":"Calls the fine-tuning job list endpoint.\n\nhttps://platform.openai.com/docs/api-reference/fine-tuning/list","ref":"OpenaiEx.FineTuning.Jobs.html#list!/2"},{"type":"function","title":"OpenaiEx.FineTuning.Jobs.list_events/2","doc":"","ref":"OpenaiEx.FineTuning.Jobs.html#list_events/2"},{"type":"function","title":"OpenaiEx.FineTuning.Jobs.list_events!/2","doc":"Calls the fine-tuning job list events endpoint.\n\nhttps://platform.openai.com/docs/api-reference/fine-tuning/events","ref":"OpenaiEx.FineTuning.Jobs.html#list_events!/2"},{"type":"function","title":"OpenaiEx.FineTuning.Jobs.new/1","doc":"Creates a new fine-tuning job request","ref":"OpenaiEx.FineTuning.Jobs.html#new/1"},{"type":"function","title":"OpenaiEx.FineTuning.Jobs.retrieve/2","doc":"","ref":"OpenaiEx.FineTuning.Jobs.html#retrieve/2"},{"type":"function","title":"OpenaiEx.FineTuning.Jobs.retrieve!/2","doc":"Calls the fine-tuning job retrieve endpoint.\n\nhttps://platform.openai.com/docs/api-reference/fine-tuning/retrieve","ref":"OpenaiEx.FineTuning.Jobs.html#retrieve!/2"},{"type":"module","title":"OpenaiEx.Images","doc":"This module provides an implementation of the OpenAI images API. The API reference can be found at https://platform.openai.com/docs/api-reference/images.","ref":"OpenaiEx.Images.html"},{"type":"function","title":"OpenaiEx.Images.create_variation/2","doc":"","ref":"OpenaiEx.Images.html#create_variation/2"},{"type":"function","title":"OpenaiEx.Images.create_variation!/2","doc":"Calls the image variation endpoint.\n\nSee the [OpenAI API Create Image Variation reference](https://platform.openai.com/docs/api-reference/images/create-variation) for more information.","ref":"OpenaiEx.Images.html#create_variation!/2"},{"type":"function","title":"OpenaiEx.Images.edit/2","doc":"","ref":"OpenaiEx.Images.html#edit/2"},{"type":"function","title":"OpenaiEx.Images.edit!/2","doc":"Calls the image edit endpoint.\n\nSee the [OpenAI API Create Image Edit reference](https://platform.openai.com/docs/api-reference/images/create-edit) for more information.","ref":"OpenaiEx.Images.html#edit!/2"},{"type":"function","title":"OpenaiEx.Images.generate/2","doc":"","ref":"OpenaiEx.Images.html#generate/2"},{"type":"function","title":"OpenaiEx.Images.generate!/2","doc":"Calls the image generation endpoint.\n\nSee the [OpenAI API Create Image reference](https://platform.openai.com/docs/api-reference/images/create) for more information.","ref":"OpenaiEx.Images.html#generate!/2"},{"type":"module","title":"OpenaiEx.Images.Edit","doc":"This module provides constructors for OpenAI Image Edit API request structure. The API reference can be found at https://platform.openai.com/docs/api-reference/images/create-edit.","ref":"OpenaiEx.Images.Edit.html"},{"type":"function","title":"OpenaiEx.Images.Edit.new/1","doc":"Creates a new image edit request","ref":"OpenaiEx.Images.Edit.html#new/1"},{"type":"module","title":"OpenaiEx.Images.Generate","doc":"This module provides constructors for the OpenAI image generation API. The API\nreference can be found at https://platform.openai.com/docs/api-reference/images/create.","ref":"OpenaiEx.Images.Generate.html"},{"type":"function","title":"OpenaiEx.Images.Generate.new/1","doc":"Creates a new image generation request\n\nExample usage:\n\n    iex> _request = OpenaiEx.Images.Generate.new(prompt: \"This is a test\")\n    %{prompt: \"This is a test\"}\n\n    iex> _request = OpenaiEx.Images.Generate.new(%{prompt: \"This is a test\"})\n    %{prompt: \"This is a test\"}","ref":"OpenaiEx.Images.Generate.html#new/1"},{"type":"module","title":"OpenaiEx.Images.Variation","doc":"This module provides constructors for OpenAI Image Variation API request structure. The API reference can be found at https://platform.openai.com/docs/api-reference/images/create-variation.","ref":"OpenaiEx.Images.Variation.html"},{"type":"function","title":"OpenaiEx.Images.Variation.new/1","doc":"Creates a new image variation request","ref":"OpenaiEx.Images.Variation.html#new/1"},{"type":"module","title":"OpenaiEx.Models","doc":"This module provides an implementation of the OpenAI Models API. Information about these models can be found at https://platform.openai.com/docs/models.","ref":"OpenaiEx.Models.html"},{"type":"function","title":"OpenaiEx.Models.delete/2","doc":"","ref":"OpenaiEx.Models.html#delete/2"},{"type":"function","title":"OpenaiEx.Models.delete!/2","doc":"Deletes a specific model.\n\nhttps://platform.openai.com/docs/api-reference/fine-tunes/delete-model","ref":"OpenaiEx.Models.html#delete!/2"},{"type":"function","title":"OpenaiEx.Models.list/1","doc":"","ref":"OpenaiEx.Models.html#list/1"},{"type":"function","title":"OpenaiEx.Models.list!/1","doc":"Lists the available models.\n\nhttps://platform.openai.com/docs/api-reference/models/list","ref":"OpenaiEx.Models.html#list!/1"},{"type":"function","title":"OpenaiEx.Models.retrieve/2","doc":"","ref":"OpenaiEx.Models.html#retrieve/2"},{"type":"function","title":"OpenaiEx.Models.retrieve!/2","doc":"Retrieves a specific model.\n\nhttps://platform.openai.com/docs/api-reference/models/retrieve","ref":"OpenaiEx.Models.html#retrieve!/2"},{"type":"module","title":"OpenaiEx.Moderations","doc":"This module provides an implementation of the OpenAI moderation API. The API reference can be found at https://platform.openai.com/docs/api-reference/moderations.","ref":"OpenaiEx.Moderations.html"},{"type":"function","title":"OpenaiEx.Moderations.create/2","doc":"","ref":"OpenaiEx.Moderations.html#create/2"},{"type":"function","title":"OpenaiEx.Moderations.create!/2","doc":"Calls the moderation endpoint.","ref":"OpenaiEx.Moderations.html#create!/2"},{"type":"function","title":"OpenaiEx.Moderations.new/1","doc":"Creates a new moderation request with the given arguments.\n\nExample usage:\n\n    iex> OpenaiEx.Moderations.new(input: \"This is a test\")\n    %{\n      input: \"This is a test\"\n    }\n\n    iex> OpenaiEx.Moderations.new(%{input: \"This is a test\"})\n    %{\n      input: \"This is a test\"\n    }","ref":"OpenaiEx.Moderations.html#new/1"},{"type":"module","title":"OpenaiEx.Responses","doc":"This module provides an implementation of the OpenAI Responses API.\nThe API reference can be found at https://platform.openai.com/docs/api-reference/responses.","ref":"OpenaiEx.Responses.html"},{"type":"function","title":"OpenaiEx.Responses.create/2","doc":"","ref":"OpenaiEx.Responses.html#create/2"},{"type":"function","title":"OpenaiEx.Responses.create/3","doc":"","ref":"OpenaiEx.Responses.html#create/3"},{"type":"function","title":"OpenaiEx.Responses.create!/2","doc":"","ref":"OpenaiEx.Responses.html#create!/2"},{"type":"function","title":"OpenaiEx.Responses.create!/3","doc":"Creates a new response.\n\nhttps://platform.openai.com/docs/api-reference/responses/create","ref":"OpenaiEx.Responses.html#create!/3"},{"type":"function","title":"OpenaiEx.Responses.delete/2","doc":"","ref":"OpenaiEx.Responses.html#delete/2"},{"type":"function","title":"OpenaiEx.Responses.delete!/2","doc":"Deletes a response.\n\nSee https://platform.openai.com/docs/api-reference/responses/delete","ref":"OpenaiEx.Responses.html#delete!/2"},{"type":"function","title":"OpenaiEx.Responses.input_items_list/2","doc":"","ref":"OpenaiEx.Responses.html#input_items_list/2"},{"type":"function","title":"OpenaiEx.Responses.input_items_list!/2","doc":"Lists input items from a response. See https://platform.openai.com/docs/api-reference/responses/input-items","ref":"OpenaiEx.Responses.html#input_items_list!/2"},{"type":"function","title":"OpenaiEx.Responses.retrieve/2","doc":"","ref":"OpenaiEx.Responses.html#retrieve/2"},{"type":"function","title":"OpenaiEx.Responses.retrieve!/2","doc":"Retrieves a response.\n\nhttps://platform.openai.com/docs/api-reference/responses/retrieve","ref":"OpenaiEx.Responses.html#retrieve!/2"},{"type":"exception","title":"OpenaiEx.Error","doc":"","ref":"OpenaiEx.Error.html"},{"type":"function","title":"OpenaiEx.Error.api_connection_error/2","doc":"","ref":"OpenaiEx.Error.html#api_connection_error/2"},{"type":"function","title":"OpenaiEx.Error.api_error/3","doc":"","ref":"OpenaiEx.Error.html#api_error/3"},{"type":"function","title":"OpenaiEx.Error.api_response_validation_error/3","doc":"","ref":"OpenaiEx.Error.html#api_response_validation_error/3"},{"type":"function","title":"OpenaiEx.Error.api_status_error/3","doc":"","ref":"OpenaiEx.Error.html#api_status_error/3"},{"type":"function","title":"OpenaiEx.Error.api_timeout_error/1","doc":"","ref":"OpenaiEx.Error.html#api_timeout_error/1"},{"type":"function","title":"OpenaiEx.Error.open_ai_error/1","doc":"","ref":"OpenaiEx.Error.html#open_ai_error/1"},{"type":"function","title":"OpenaiEx.Error.sse_timeout_error/0","doc":"","ref":"OpenaiEx.Error.html#sse_timeout_error/0"},{"type":"function","title":"OpenaiEx.Error.sse_user_cancellation/0","doc":"","ref":"OpenaiEx.Error.html#sse_user_cancellation/0"},{"type":"function","title":"OpenaiEx.Error.status_error/3","doc":"","ref":"OpenaiEx.Error.html#status_error/3"},{"type":"extras","title":"OpenaiEx User Guide","doc":"# OpenaiEx User Guide\n\n```elixir\nMix.install([\n  {:openai_ex, \"~> 0.9.8\"},\n  # {:openai_ex, path: Path.join(__DIR__, \"..\")},\n  {:kino, \"~> 0.15.3\"}\n])\n```","ref":"userguide.html"},{"type":"extras","title":"Introduction - OpenaiEx User Guide","doc":"`OpenaiEx` is an Elixir library that provides a community-maintained OpenAI API client.\n\nThe main user guide is a livebook, so you should be able to run everything without any setup. The user guide is also the test suite. It is run before every version release, so it is always up to date with the library.\n\n> Portions of this project were developed with assistance from ChatGPT 3.5 and 4, as well as Claude 3 Opus and Claude Sonnets 3.5, 3.6 and 3.7. However, every line of code is human curated (by me, @restlessronin 😇). AI collaboration facilitated by [llm-context](https://github.com/cyberchitta/llm-context.py).\n\nAll API endpoints and features (as of Mar 16, 2025) are supported, including the most recent Responses API (proposed replacement for Chat Completion).\n\nConfiguration of Finch pools and API base url are supported.\n\nThere are some differences compared to other elixir openai wrappers.\n\n* I tried to faithfully mirror the naming/structure of the official python api. For example, content that is already in memory can be uploaded as part of a request, it doesn't have to be read from a file at a local path.\n* I was developing for a livebook use-case, so I don't have any config, only environment variables.\n* Streaming API versions, with request cancellation, are supported.\n* The underlying transport is finch, rather than httpoison\n* 3rd Party (including local) LLMs with an OpenAI proxy, as well as the **Azure OpenAI API**, are considered legitimate use cases.\n\nTo learn how to use OpenaiEx, you can refer to the relevant parts of the official OpenAI API reference documentation, which we link to throughout this document.\n\nThis file is an executable Livebook, which means you can interactively run and modify the code samples provided. We encourage you to open it in Livebook and try out the code for yourself!","ref":"userguide.html#introduction"},{"type":"extras","title":"Installation - OpenaiEx User Guide","doc":"You can install OpenaiEx using Mix:","ref":"userguide.html#installation"},{"type":"extras","title":"In Livebook - OpenaiEx User Guide","doc":"Add the following code to the first connection cell:\n\n<!-- livebook:{\"force_markdown\":true} -->\n\n```elixir\nMix.install(\n  [\n    {:openai_ex, \"~> 0.9.8\"}\n  ]\n)\n```","ref":"userguide.html#in-livebook"},{"type":"extras","title":"In a Mix Project - OpenaiEx User Guide","doc":"Add the following to your mix.exs file:\n\n<!-- livebook:{\"force_markdown\":true} -->\n\n```elixir\ndef deps do\n  [\n    {:openai_ex, \"~> 0.9.8\"}\n  ]\nend\n```","ref":"userguide.html#in-a-mix-project"},{"type":"extras","title":"Authentication - OpenaiEx User Guide","doc":"To authenticate with the OpenAI API, you will need an API key. We recommend storing your API key in an environment variable. Since we are using Livebook, we can store this and other environment variables as [Livebook Hub Secrets](https://news.livebook.dev/hubs-and-secret-management---launch-week-1---day-3-3tMaJ2).\n\n```elixir\napikey = System.fetch_env!(\"LB_OPENAI_API_KEY\")\nopenai = OpenaiEx.new(apikey)\n```\n\nYou can also specify an organization if you are a member of more than one:\n\n```elixir\n# organization = System.fetch_env!(\"LB_OPENAI_ORGANIZATION\")\n# openai = OpenaiEx.new(apikey, organization)\n```\n\nFor more information on authentication, see the [OpenAI API Authentication reference](https://platform.openai.com/docs/api-reference/authentication).","ref":"userguide.html#authentication"},{"type":"extras","title":"Configuration - OpenaiEx User Guide","doc":"There are a few places where configuration seemed necessary.","ref":"userguide.html#configuration"},{"type":"extras","title":"Receive Timeout - OpenaiEx User Guide","doc":"The default receive timeout is 15 seconds. If you are seeing longer latencies, you can override the default with\n\n```elixir\n# set receive timeout to 45 seconds\nopenai = OpenaiEx.new(apikey) |> OpenaiEx.with_receive_timeout(45_000)\n```","ref":"userguide.html#receive-timeout"},{"type":"extras","title":"Finch Instance - OpenaiEx User Guide","doc":"In production scenarios where you want to explicitly tweak the Finch pool, you can create a new Finch instance using\n\n<!-- livebook:{\"force_markdown\":true} -->\n\n```elixir\nFinch.start_link(\n    name: MyConfiguredFinch,\n    pools: ...\n)\n```\n\nYou can use this instance of Finch (instead of the default `OpenaiEx.Finch`) by setting the finch name\n\n<!-- livebook:{\"force_markdown\":true} -->\n\n```elixir\nopenai_with_custom_finch = openai |> with_finch_name(MyConfiguredFinch)\n```\n\n<!-- livebook:{\"break_markdown\":true} -->","ref":"userguide.html#finch-instance"},{"type":"extras","title":"Base Url - OpenaiEx User Guide","doc":"There are times, such as when using a local LLM (like Ollama) with an OpenAI proxy, when you need to reset the base url of the API. This is generally only applicable for chat and chat completion endpoints and can be accomplished by\n\n```elixir\n# in this example, our development livebook server is running in a docker dev container while \n# the local llm is running on the host machine\nproxy_openai =\n  OpenaiEx.new(apikey) |> OpenaiEx.with_base_url(\"http://host.docker.internal:8000/v1\")\n```","ref":"userguide.html#base-url"},{"type":"extras","title":"Using an LLM gateway (e.g. [Portkey](https://portkey.ai/)) - OpenaiEx User Guide","doc":"LLM gateways are used to provide a virtual interface to multiple LLM providers behind a single API endpoint.\n\nGenerally they work on the basis of additional HTTP headers being added that specify the model to use, the provider to use, and possibly other parameters.\n\nFor example, to configure your client for openai using the portkey gateway, you would do this:\n\n```elixir\nopenai_api_key = \"an-openai-api-key\"\nportkey_api_key = \"a-portkey-api-key\"\n\nOpenaiEx.new(openai_api_key) \n  |> OpenaiEx.with_base_url(\"https://api.portkey.ai/v1\") \n  |> OpenaiEx.with_additional_headers(%{\"x-portkey-api-key\"=>portkey_api_key, \"x-portkey-provider\"=>\"openai\"})\n```\n\nsimilarly, for Anthropic, you would do this:\n\n```elixir\nanthropic_api_key = \"some-anthropic-api-key\"\n\nOpenaiEx.new(anthropic_api_key) \n  |> OpenaiEx.with_base_url(\"https://api.portkey.ai/v1\") \n  |> OpenaiEx.with_additional_headers(%{\"x-portkey-api-key\"=>portkey_api_key, \"x-portkey-provider\"=>\"anthropic\"})\n```","ref":"userguide.html#using-an-llm-gateway-e-g-portkey-https-portkey-ai"},{"type":"extras","title":"Azure OpenAI - OpenaiEx User Guide","doc":"The Azure OpenAI API replicates the Completion, Chat Completion and Embeddings endpoints from OpenAI.\n\nHowever, it modifies the base URL as well as the endpoint path, and adds a parameter to the URL query. These modifications are accommodated with the following calls:\n\nfor non Entra Id\n\n<!-- livebook:{\"force_markdown\":true} -->\n\n```elixir\nopenai = OpenaiEx._for_azure(azure_api_id, resource_name, deployment_id, api_version)\n```\n\nand for Entra Id\n\n<!-- livebook:{\"force_markdown\":true} -->\n\n```elixir\nopenai = OpenaiEx.new(entraId) |> OpenaiEx._for_azure(resource_name, deployment_id, api_version)\n```\n\nThese methods will be supported as long as the Azure version does not deviate too far from the base OpenAI API.","ref":"userguide.html#azure-openai"},{"type":"extras","title":"Error Handling - OpenaiEx User Guide","doc":"OpenaiEx provides robust error handling to support both interactive and non-interactive usage. There are two main ways to handle errors:","ref":"userguide.html#error-handling"},{"type":"extras","title":"Error Tuples - OpenaiEx User Guide","doc":"Most functions in OpenaiEx return `:ok` and `:error` tuples. This allows for pattern matching and explicit error handling:\n\n<!-- livebook:{\"force_markdown\":true} -->\n\n```elixir\ncase OpenaiEx.Chat.Completions.create(openai, chat_req) do\n  {:ok, response} -> # Handle successful response\n  {:error, error} -> # Handle error\nend\n```","ref":"userguide.html#error-tuples"},{"type":"extras","title":"Exceptions - OpenaiEx User Guide","doc":"For scenarios where you prefer exceptions, OpenaiEx provides bang (!) versions of functions that raise exceptions on errors:\n\n<!-- livebook:{\"force_markdown\":true} -->\n\n```elixir\ntry do\n  response = OpenaiEx.Chat.Completions.create!(openai, chat_req)\n  # Handle successful response\nrescue\n  e in OpenaiEx.Error -> # Handle exception\nend\n```","ref":"userguide.html#exceptions"},{"type":"extras","title":"Error Types - OpenaiEx User Guide","doc":"OpenaiEx closely follows the error types defined in the official OpenAI Python library. For a comprehensive list and description of these error types, please refer to the [OpenAI API Error Types documentation](https://platform.openai.com/docs/guides/error-codes/api-errors).\n\nIn addition to these standard error types, OpenaiEx defines two specific error types for handling streaming operations:\n\n* `SSETimeoutError`: Raised when a streaming response times out\n* `SSECancellationError`: Raised when a user initiates a stream cancellation\n\nFor more details on specific error types and their attributes, refer to the `OpenaiEx.Error` module documentation.","ref":"userguide.html#error-types"},{"type":"extras","title":"Model - OpenaiEx User Guide","doc":"","ref":"userguide.html#model"},{"type":"extras","title":"List Models - OpenaiEx User Guide","doc":"To list all available models, use the [`Model.list()`](https://platform.openai.com/docs/api-reference/models/list) function:\n\n```elixir\nalias OpenaiEx.Models\n\nopenai |> Models.list()\n```","ref":"userguide.html#list-models"},{"type":"extras","title":"Retrieve Models - OpenaiEx User Guide","doc":"To retrieve information about a specific model, use the [`Model.retrieve()`](https://platform.openai.com/docs/api-reference/models/retrieve) function:\n\n```elixir\nopenai |> Models.retrieve(\"gpt-4o-mini\")\n```\n\nFor more information on using models, see the [OpenAI API Models reference](https://platform.openai.com/docs/api-reference/models).","ref":"userguide.html#retrieve-models"},{"type":"extras","title":"Chat Completion - OpenaiEx User Guide","doc":"To generate a chat completion, you need to define a chat completion request structure using the `ChatCompletion.new()` function. This function takes several parameters, such as the model ID and a list of chat messages. We have a module `ChatMessage` which helps create messages in the [chat format](https://platform.openai.com/docs/guides/chat/introduction).\n\n```elixir\nalias OpenaiEx.Chat\nalias OpenaiEx.ChatMessage\nalias OpenaiEx.MsgContent\n\nchat_req =\n  Chat.Completions.new(\n    model: \"gpt-4o-mini\",\n    messages: [\n      ChatMessage.user(\n        \"Give me some background on the elixir language. Why was it created? What is it used for? What distinguishes it from other languages? How popular is it?\"\n      )\n    ]\n  )\n```\n\nYou are able to pass images to the API by creating a message.\n\n```elixir\nChatMessage.user(\n  MsgContent.image_url(\n    \"https://raw.githubusercontent.com/restlessronin/openai_ex/main/assets/images/starmask.png\"\n  )\n)\n```\n\nYou can generate a chat completion using the [`ChatCompletion.create()`](https://platform.openai.com/docs/api-reference/chat/completions/create) function:\n\n```elixir\n{:ok, chat_response} = openai |> Chat.Completions.create(chat_req)\n```\n\nFor a more in-depth example of `ChatCompletion`, check out the [Deeplearning.AI OrderBot Livebook](https://hexdocs.pm/openai_ex/dlai_orderbot.html).\n\nYou can also call the endpoint and have it stream the response. This returns the result as a series of tokens, which have to be put together in code.\n\nTo use the stream option, call the `ChatCompletion.create()` function with `stream: true` (and `stream_options` set to `{%include_usage: true}` to recieve usage information)\n\n```elixir\n{:ok, chat_stream} = openai |> Chat.Completions.create(chat_req |> Map.put(:stream_options, %{include_usage: true}), stream: true)\nIO.puts(inspect(chat_stream))\nIO.puts(inspect(chat_stream.task_pid))\nchat_stream.body_stream |> Stream.flat_map(& &1) |> Enum.each(fn x -> IO.puts(inspect(x)) end)\n```","ref":"userguide.html#chat-completion"},{"type":"extras","title":"Canceling a streaming request - OpenaiEx User Guide","doc":"The `chat_stream.task_pid` can be used in conjunction with `OpenaiEx.HttpSse.cancel_request/1` to cancel an ongoing request.\n\nYou need to check the return `chat_stream.status` field. In case the status is *not* 2XX, the `body_stream` and `task_pid` fields are not available. Instead, an `error` field will be returned.\n\nFor example\n\n```elixir\nbad_req = Chat.Completions.new(model: \"code-llama\", messages: [])\n{:error, err_resp} = openai |> Chat.Completions.create(bad_req, stream: true)\n```\n\nFor a detailed example of the use of the streaming `ChatCompletion` API, **including how to cancel an ongoing request**, check out [Streaming Orderbot](https://hexdocs.pm/openai_ex/streaming_orderbot.html), the streaming equivalent of the prior example.","ref":"userguide.html#canceling-a-streaming-request"},{"type":"extras","title":"Stream Timeout - OpenaiEx User Guide","doc":"While OpenAI's official API implementation typically doesn't require explicit timeout handling for streams, some third-party implementations of the OpenAI API may benefit from custom timeout settings. OpenaiEx provides a way to set a stream-specific timeout to handle these cases.\n\nYou can set a stream-specific timeout using the `with_stream_timeout` function:\n\n```elixir\n# Set a stream timeout of 30 seconds\nopenai_with_timeout = openai |> OpenaiEx.with_stream_timeout(30_000)\n```\n\nThis is particularly useful when working with third-party OpenAI API implementations that may have different performance characteristics than the official API.","ref":"userguide.html#stream-timeout"},{"type":"extras","title":"Exception Handling for Streams - OpenaiEx User Guide","doc":"When working with streams, it's important to handle potential exceptions that may occur during stream processing. OpenaiEx uses a custom exception type for stream-related errors. Here's how you can handle these exceptions:\n\n```elixir\nalias OpenaiEx.Error\n\nprocess_stream = fn openai, request ->\n  response = Chat.Completions.create!(openai, request, stream: true)\n  \n  try do\n    response.body_stream\n    |> Stream.flat_map(& &1)\n    |> Enum.each(fn chunk ->\n      # Process each chunk here\n      IO.inspect(chunk)\n    end)\n  rescue\n    e in OpenaiEx.Error ->\n      case e do\n        %{kind: :sse_cancellation} -> \n          IO.puts(\"Stream was canceled\")\n          {:error, :canceled, e.message}\n        %{kind: :sse_timeout_error} -> \n          IO.puts(\"Timeout on SSE stream\")\n          {:error, :timeout, e.message}\n        _ -> \n          IO.puts(\"Unknown error occurred\")\n          {:error, :unknown, e.message}\n      end\n    e ->\n      IO.puts(\"An unexpected error occurred\")\n      {:error, :unexpected, Exception.message(e)}\n  end\nend\n\n# Usage\nchat_req = Chat.Completions.new(\n  model: \"gpt-4o-mini\",\n  messages: [ChatMessage.user(\"Tell me a short story about a brave knight\")],\n  max_tokens: 500\n)\n\n# Use the OpenaiEx struct with custom stream timeout\nresult = process_stream.(openai_with_timeout, chat_req)\ncase result do\n  {:error, type, message} ->\n    IO.puts(\"Error type: #{type}\")\n    IO.puts(\"Error message: #{message}\")\n  _ ->\n    IO.puts(\"Stream processed successfully\")\nend\n```\n\nIn this example, we define a `process_stream` function that handles different types of stream exceptions:\n\n* `:canceled`: The stream was canceled. We return an error tuple.\n* `:timeout`: The stream timed out. We return an error tuple.\n* Any other `OpenaiEx.Exception`: We treat it as an unknown error.\n* Any other exception: We treat it as an unexpected error.\n\nThis approach allows you to gracefully handle different types of stream-related errors and take appropriate actions.\n\nFor more information on generating chat completions, see the [OpenAI API Chat Completions reference](https://platform.openai.com/docs/api-reference/chat).","ref":"userguide.html#exception-handling-for-streams"},{"type":"extras","title":"Function(Tool) Calling - OpenaiEx User Guide","doc":"In OpenAI's `ChatCompletion` endpoint, you can use the function calling feature to call a custom function and pass its result as part of the conversation. Here's an example of how to use the function calling feature:\n\nFirst, we set up the function specification and completion request. The function specification defines the name, description, and parameters of the function we want to call. In this example, we define a function called `get_current_weather` that takes a `location` parameter and an optional `unit` parameter. The completion request includes the function specification, the conversation history, and the model we want to use.\n\n```elixir\ntool_spec =\n  Jason.decode!(\"\"\"\n    {\"type\": \"function\",\n     \"function\": {\n        \"name\": \"get_current_weather\",\n        \"description\": \"Get the current weather in a given location\",\n        \"parameters\": {\n          \"type\": \"object\",\n          \"properties\": {\n            \"location\": {\n              \"type\": \"string\",\n              \"description\": \"The city and state, e.g. San Francisco, CA\"\n            },\n            \"unit\": {\n              \"type\": \"string\",\n              \"enum\": [\"celsius\", \"fahrenheit\"]\n            }\n          },\n          \"required\": [\"location\"]\n        }\n      }\n    }\n  \"\"\")\n\nrev_msgs = [\n  ChatMessage.user(\"What's the weather like in Boston today?\")\n]\n\nfn_req =\n  Chat.Completions.new(\n    model: \"gpt-4o-mini\",\n    messages: rev_msgs |> Enum.reverse(),\n    tools: [tool_spec],\n    tool_choice: \"auto\"\n  )\n```\n\nNext, we call the OpenAI endpoint to get a response that includes the function call.\n\n```elixir\n{:ok, fn_response} = openai |> Chat.Completions.create(fn_req)\n```\n\nWe extract the function call from the response and call the appropriate function with the given parameters. In this example, we define a map of functions that maps function names to their implementations. We then use the function name and arguments from the function call to look up the appropriate function and call it with the given parameters.\n\n```elixir\nfn_message = fn_response[\"choices\"] |> Enum.at(0) |> Map.get(\"message\")\ntool_call = fn_message |> Map.get(\"tool_calls\") |> List.first()\ntool_id = tool_call |> Map.get(\"id\")\nfn_call = tool_call |> Map.get(\"function\")\n\nfunctions = %{\n  \"get_current_weather\" => fn location, unit ->\n    %{\n      \"location\" => location,\n      \"temperature\" => \"72\",\n      \"unit\" => unit,\n      \"forecast\" => [\"sunny\", \"windy\"]\n    }\n    |> Jason.encode!()\n  end\n}\n\nfn_name = fn_call[\"name\"]\nfn_args = fn_call[\"arguments\"] |> Jason.decode!()\n\nlocation = fn_args[\"location\"]\nunit = unless is_nil(fn_args[\"unit\"]), do: fn_args[\"unit\"], else: \"fahrenheit\"\n\nfn_value = functions[fn_name].(location, unit)\n```\n\nWe then pass the returned value back to the ChatCompletion endpoint with the conversation history to that point to get the final response.\n\n```elixir\nlatest_msgs = [ChatMessage.tool(tool_id, fn_name, fn_value) | [fn_message | rev_msgs]]\n\nfn_req_2 =\n  Chat.Completions.new(\n    model: \"gpt-4o-mini\",\n    messages: latest_msgs |> Enum.reverse()\n  )\n\n{:ok, fn_response_2} = openai |> Chat.Completions.create(fn_req_2)\n```\n\nThe final response includes the result of the function call integrated into the conversation.","ref":"userguide.html#function-tool-calling"},{"type":"extras","title":"Storing and Managing Chat Completions - OpenaiEx User Guide","doc":"OpenAI allows storing chat completions for later retrieval. This is useful for conversation history, auditing, or analytics purposes.\n\n#### Store a Chat Completion\n\nTo store a chat completion, include `store: true` in your request:\n\n```elixir\nstored_chat_req = \n  Chat.Completions.new(\n    model: \"gpt-4o-mini\",\n    messages: [\n      ChatMessage.user(\"Explain quantum computing briefly\")\n    ],\n    store: true\n  )\n\n{:ok, stored_completion} = openai |> Chat.Completions.create(stored_chat_req)\ncompletion_id = stored_completion[\"id\"]\n```\n\n#### Retrieve a Stored Chat Completion\n\nUse [`Chat.Completions.retrieve()`](https://platform.openai.com/docs/api-reference/chat/get) to fetch a previously stored chat completion:\n\n```elixir\n{:ok, retrieved_completion} = openai |> Chat.Completions.retrieve(completion_id: completion_id)\n```\n\n#### Get Messages from a Chat Completion\n\nTo access the messages in a stored chat completion, use [`Chat.Completions.messages_list()`](https://platform.openai.com/docs/api-reference/chat/getMessages):\n\n```elixir\n{:ok, messages} = openai |> Chat.Completions.messages_list(completion_id)\n```\n\n#### List Stored Chat Completions\n\nTo get a list of all your stored chat completions, use [`Chat.Completions.list()`](https://platform.openai.com/docs/api-reference/chat/list):\n\n```elixir\n{:ok, completions_list} = openai |> Chat.Completions.list()\n```\n\nYou can filter by metadata, model, or use pagination parameters:\n\n```elixir\n{:ok, filtered_completions} = openai |> Chat.Completions.list(\n  metadata: %{project: \"research\"},\n  model: \"gpt-4o-mini\",\n  limit: 10,\n  order: \"desc\"\n)\n```\n\n#### Update a Chat Completion\n\nYou can update the metadata of a stored chat completion using [`Chat.Completions.update()`](https://platform.openai.com/docs/api-reference/chat/update):\n\n```elixir\n{:ok, updated_completion} = openai |> Chat.Completions.update(\n  completion_id: completion_id,\n  metadata: %{category: \"technical\", reviewed: \"true\"}\n)\n```\n\n#### Delete a Chat Completion\n\nTo remove a stored chat completion, use [`Chat.Completions.delete()`](https://platform.openai.com/docs/api-reference/chat/delete):\n\n```elixir\n{:ok, delete_result} = openai |> Chat.Completions.delete(completion_id: completion_id)\n```\n\nFor more information on managing chat completions, see the [OpenAI API Chat reference](https://platform.openai.com/docs/api-reference/chat).","ref":"userguide.html#storing-and-managing-chat-completions"},{"type":"extras","title":"Responses - OpenaiEx User Guide","doc":"```elixir\nalias OpenaiEx.Responses\n```\n\nThe Responses API combines features of Chat Completions and Assistants, providing a streamlined way to interact with OpenAI models. It supports single-turn and multi-turn conversations, tool use (including built-in tools), and optional server-side state management. It is the recommended approach for building applications that would previously have used the Assistants API, which will be sunset in the first half of 2026.","ref":"userguide.html#responses"},{"type":"extras","title":"Create a Response - OpenaiEx User Guide","doc":"Use [`Responses.create()`](https://platform.openai.com/docs/api-reference/responses/create) to generate a response. You can provide a simple prompt or a list of `ChatMessage` structs for multi-turn conversations. The `store: true` option enables server-side state management.\n\nFirst, a simple example with a single prompt:\n\n```elixir\nresponse_req = %{\n  model: \"gpt-4o-mini\",\n  input: \"Explain the theory of relativity.\",\n  store: true # Optional: Enables state management\n}\n\n{:ok, response} = openai |> Responses.create(response_req)\n```\n\nNext, a multi-turn example using `ChatMessage` structs:\n\n```elixir\nresponse_req2 = %{\n  model: \"gpt-4o-mini\",\n  input: [\n    ChatMessage.user(\"What is the capital of France?\"),\n    ChatMessage.assistant(\"Paris.\"),\n    ChatMessage.user(\"And what is the capital of Germany?\")\n  ],\n  store: true\n}\n\n{:ok, response2} = openai |> Responses.create(response_req2)\n```","ref":"userguide.html#create-a-response"},{"type":"extras","title":"Streaming Responses - OpenaiEx User Guide","doc":"The Responses API supports streaming, activated by passing `stream: true` to the `create` function. This returns the result as a series of semantic events, which can be processed and displayed as they arrive.\n\nHere's a simple example that prints each event:\n\n```elixir\nstreaming_req = %{\n  model: \"gpt-4o-mini\",\n  input: \"Tell me a 300 word story about a cat.\",\n  store: true  # Streaming works with or without storing the response\n}\n\n{:ok, stream} = openai |> Responses.create(streaming_req, stream: true)\n\nstream.body_stream\n|> Stream.flat_map(& &1)\n|> Enum.each(fn event ->\n  IO.puts(inspect(event))\nend)\n```\n\nHere's a more detailed example that demonstrates how to handle different event types using pattern matching:\n\n```elixir\nstreaming_req = %{\n  model: \"gpt-4o-mini\",\n  input: \"Tell me a 500 word story about a cat.\",\n  store: true  # Streaming works with or without storing the response\n}\n\n{:ok, stream} = openai |> Responses.create(streaming_req, stream: true)\n\nstream.body_stream\n|> Stream.flat_map(& &1)\n|> Enum.each(fn event ->\n  case event do\n    %{data: data, event: \"response.created\"} ->\n      # Initial response creation.  Contains metadata.\n      IO.puts(\"Response Created: #{inspect(data)}\")\n\n    %{data: data, event: \"response.in_progress\"} ->\n       # The response is still being generated.\n      IO.puts(\"Response In Progress: #{inspect(data)}\")\n\n    %{data: data, event: \"response.output_item.added\"} ->\n      # An output item (e.g. text, tool call) was added to the response\n      IO.puts(\"Output Item Added: #{inspect(data)}\")\n\n    %{data: data, event: \"response.content_part.added\"} ->\n      # A content part was added (e.g. a chunk of text for a text output item.)\n      IO.puts(\"Content Part Added: #{inspect(data)}\")\n\n    %{data: %{\"delta\" => delta}, event: \"response.output_text.delta\"} ->\n      # Text delta (a chunk of text).  Write this to the console/UI.\n      IO.write(delta)\n\n    %{data: data, event: \"response.output_text.done\"} ->\n       # The text output is complete.\n      IO.puts(\"\\nOutput Text Done: #{inspect(data)}\")\n\n    %{data: data, event: \"response.content_part.done\"} ->\n      # A content part is done (e.g., end of a text chunk)\n      IO.puts(\"Content Part Done: #{inspect(data)}\")\n\n    %{data: data, event: \"response.output_item.done\"} ->\n      # An output item is done (e.g. text generation or tool call)\n      IO.puts(\"Output Item Done: #{inspect(data)}\")\n\n    %{data: data, event: \"response.completed\"} ->\n      # The entire response is complete.\n      IO.puts(\"\\nResponse Completed: #{inspect(data)}\")\n\n    other ->\n      # Handle other event types.  See API reference for full list.\n      IO.puts(\"Other Event: #{inspect(other)}\")\n  end\nend)\n```","ref":"userguide.html#streaming-responses"},{"type":"extras","title":"Streaming with Tool Calling - OpenaiEx User Guide","doc":"Streaming also works when using tools.  The stream will include events related to tool usage, such as `response.output_item.added` when a tool call is initiated and `response.output_tool_call.*` events for the tool call's progress and results.\n\nHere's an example using the built-in `web_search_preview` tool, demonstrating how to handle tool-related events in the stream:\n\n```elixir\nstreaming_req_with_tool = %{\n  model: \"gpt-4o-mini\",\n  input: \"What's the latest news on the James Webb Telescope?\",\n  tools: [%{type: \"web_search_preview\"}],\n  store: true\n}\n\n{:ok, stream} = openai |> Responses.create(streaming_req_with_tool, stream: true)\n\nstream.body_stream\n|> Stream.flat_map(& &1)\n|> Enum.each(fn event ->\n  case event do\n    %{data: data, event: \"response.created\"} ->\n      IO.puts(\"Response Created: #{inspect(data)}\")\n\n    %{data: data, event: \"response.in_progress\"} ->\n      IO.puts(\"Response In Progress: #{inspect(data)}\")\n\n    %{data: data, event: \"response.output_item.added\"} ->\n      IO.puts(\"Output Item Added: #{inspect(data)}\")\n\n    %{data: data, event: \"response.content_part.added\"} ->\n      IO.puts(\"Content Part Added: #{inspect(data)}\")\n\n    %{data: %{\"delta\" => delta}, event: \"response.output_text.delta\"} ->\n      IO.write(delta)\n\n    %{data: data, event: \"response.output_text.done\"} ->\n      IO.puts(\"\\nOutput Text Done: #{inspect(data)}\")\n\n    %{data: data, event: \"response.content_part.done\"} ->\n      IO.puts(\"Content Part Done: #{inspect(data)}\")\n\n    %{data: data, event: \"response.output_item.done\"} ->\n      IO.puts(\"Output Item Done: #{inspect(data)}\")\n\n    %{data: data, event: \"response.completed\"} ->\n      IO.puts(\"\\nResponse Completed: #{inspect(data)}\")\n\n     %{data: data, event: \"response.output_tool_call.started\"} ->\n      IO.puts(\"Tool Call Started: #{inspect(data)}\")\n\n    %{data: data, event: \"response.output_tool_call.in_progress\"} ->\n      IO.puts(\"Tool Call In Progress: #{inspect(data)}\")\n\n    %{data: data, event: \"response.output_tool_call.completed\"} ->\n      IO.puts(\"Tool Call Completed: #{inspect(data)}\")\n\n    %{data: data, event: \"response.output_tool_call.failed\"} ->\n      IO.puts(\"Tool Call Failed: #{inspect(data)}\")\n\n    %{\n      data: %{\n        \"index\" => index,\n        \"id\" => id,\n        \"type\" => type,\n        \"web_search_preview\" => %{\"query\" => query}\n      },\n      event: \"response.output_tool_call.delta\"\n    } ->\n      IO.puts(\n        \"Tool Call Delta (index=#{index}, id=#{id}, type=#{type}, query=#{query})\"\n      )\n\n    other ->\n      # Handle other event types.\n      IO.puts(\"Other Event: #{inspect(other)}\")\n  end\nend)\n```\n\nThis example shows how to handle `response.output_tool_call.*` events to track the progress of tool calls within the stream, specifically for the `web_search_preview` tool.","ref":"userguide.html#streaming-with-tool-calling"},{"type":"extras","title":"Retrieve a Response - OpenaiEx User Guide","doc":"If `store` was set to `true`, you can retrieve the full response object (including conversation history) using [`Responses.retrieve()`](https://platform.openai.com/docs/api-reference/responses/get). Response objects are automatically deleted after 30 days.\n\n```elixir\nresponse_id = response[\"id\"]\n\n{:ok, retrieved_response} = openai |> Responses.retrieve(response_id: response_id)\n# With optional parameters\n{:ok, retrieved_response} = openai |> Responses.retrieve([\n  response_id: response_id,\n  include: [\"output[*].file_search_call.search_results\", \"output[*].web_search_call.search_results\", \"file_search_call.results\", \"web_search_call.results\", \"message.input_image.image_url\"]\n])\n```","ref":"userguide.html#retrieve-a-response"},{"type":"extras","title":"List Input Items from a Response - OpenaiEx User Guide","doc":"To access the input items from a stored response, use [`Responses.input_items_list()`](https://platform.openai.com/docs/api-reference/responses/input-items):\n\n```elixir\n{:ok, input_items} = openai |> Responses.input_items_list([\n  response_id: response_id\n])\n```\n\nYou can paginate through large input lists:\n\n```elixir\n{:ok, input_items} = openai |> Responses.input_items_list([\n  response_id: response_id\n])\n\n# If there are more items and we want to paginate\nif input_items[\"has_more\"] do\n  # Use the last_id from the first request to get the next page\n  last_id = input_items[\"last_id\"]\n  \n  {:ok, next_page_items} = openai |> Responses.input_items_list([\n    response_id: response_id,\n    limit: 10, \n    after: last_id,\n    order: \"desc\"\n  ])\n  IO.puts(next_page_items)\nend\n```","ref":"userguide.html#list-input-items-from-a-response"},{"type":"extras","title":"Delete a Response - OpenaiEx User Guide","doc":"To remove a stored response, use [`Responses.delete()`](https://platform.openai.com/docs/api-reference/responses/delete):\n\n```elixir\n{:ok, delete_result} = openai |> Responses.delete(response_id: response_id)\n```\n\nThis allows you to clean up stored responses that are no longer needed.\n\nFor more information on the Responses API, see the [OpenAI API Responses Reference](https://platform.openai.com/docs/api-reference/responses).","ref":"userguide.html#delete-a-response"},{"type":"extras","title":"Image - OpenaiEx User Guide","doc":"","ref":"userguide.html#image"},{"type":"extras","title":"Generate Image - OpenaiEx User Guide","doc":"We define the image creation request structure using the `Image.new` function\n\n```elixir\nalias OpenaiEx.Images\n\nimg_req = Images.Generate.new(prompt: \"An adorable baby sea otter\", size: \"256x256\", n: 1)\n```\n\nThen call the [`Image.create()`](https://platform.openai.com/docs/api-reference/images/create) function to generate the images.\n\n```elixir\n{:ok, img_response} = openai |> Images.generate(img_req)\n```\n\nFor more information on generating images, see the [OpenAI API Image reference](https://platform.openai.com/docs/api-reference/images).\n\n#### Fetch the generated images\n\nWith the information in the image response, we can fetch the images from their URLs\n\n```elixir\nfetch_blob = fn url ->\n  Finch.build(:get, url) |> Finch.request!(OpenaiEx.Finch) |> Map.get(:body)\nend\n```\n\n```elixir\nfetched_images = img_response[\"data\"] |> Enum.map(fn i -> i[\"url\"] |> fetch_blob.() end)\n```\n\n#### View the generated images\n\nFinally, we can render the images using Kino\n\n```elixir\nfetched_images\n|> Enum.map(fn r -> r |> Kino.Image.new(\"image/png\") |> Kino.render() end)\n```\n\n```elixir\nimg_to_expmt = fetched_images |> List.first()\n```","ref":"userguide.html#generate-image"},{"type":"extras","title":"Edit Image - OpenaiEx User Guide","doc":"We define an image edit request structure using the `Images.Edit.new()` function. This function requires an image and a mask. For the image, we will use the one that we received. Let's load the mask from a URL.\n\n```elixir\n# if you're having problems downloading raw github content, you may need to manually set your DNS server to \"8.8.8.8\" (google)\nstar_mask =\n  fetch_blob.(\n    \"https://raw.githubusercontent.com/restlessronin/openai_ex/main/assets/images/starmask.png\"\n  )\n\n# star_mask = OpenaiEx.new_file(path: Path.join(__DIR__, \"../assets/images/starmask.png\"))\n```\n\nSet up the image edit request with image, mask and prompt.\n\n```elixir\nimg_edit_req =\n  Images.Edit.new(\n    image: img_to_expmt,\n    mask: star_mask,\n    size: \"256x256\",\n    prompt: \"Image shows a smiling Otter\"\n  )\n```\n\nWe then call the [`Image.create_edit()`]() function\n\n```elixir\n{:ok, img_edit_response} = openai |> Images.edit(img_edit_req)\n```\n\nand view the result\n\n```elixir\nimg_edit_response[\"data\"]\n|> Enum.map(fn i -> i[\"url\"] |> fetch_blob.() |> Kino.Image.new(\"image/png\") |> Kino.render() end)\n```","ref":"userguide.html#edit-image"},{"type":"extras","title":"Image Variations - OpenaiEx User Guide","doc":"We define an image variation request structure using the `Images.Variation.new()` function. This function requires an image.\n\n```elixir\nimg_var_req = Images.Variation.new(image: img_to_expmt, size: \"256x256\")\n```\n\nThen call the [`Image.create_variation()`](https://platform.openai.com/docs/api-reference/images/create-variation) function to generate the images.\n\n<!-- livebook:{\"break_markdown\":true} -->\n\n###\n\n```elixir\n{:ok, img_var_response} = openai |> Images.create_variation(img_var_req)\n```\n\n```elixir\nimg_var_response[\"data\"]\n|> Enum.map(fn i -> i[\"url\"] |> fetch_blob.() |> Kino.Image.new(\"image/png\") |> Kino.render() end)\n```\n\nFor more information on images variations, see the [OpenAI API Image Variations reference](https://platform.openai.com/docs/api-reference/images/create-variation).","ref":"userguide.html#image-variations"},{"type":"extras","title":"Embedding - OpenaiEx User Guide","doc":"Define the embedding request structure using `Embedding.new`.\n\n```elixir\nalias OpenaiEx.Embeddings\n\nemb_req =\n  Embeddings.new(\n    model: \"text-embedding-ada-002\",\n    input: \"The food was delicious and the waiter...\"\n  )\n```\n\nThen call the [`Embedding.create()`]() function.\n\n```elixir\n{:ok, emb_response} = openai |> Embeddings.create(emb_req)\n```\n\nFor more information on generating embeddings, see the [OpenAI API Embedding reference](https://platform.openai.com/docs/api-reference/embeddings/create)","ref":"userguide.html#embedding"},{"type":"extras","title":"Audio - OpenaiEx User Guide","doc":"```elixir\nalias OpenaiEx.Audio\n```","ref":"userguide.html#audio"},{"type":"extras","title":"Create speech - OpenaiEx User Guide","doc":"<!-- livebook:{\"break_markdown\":true} -->\n\nFor text to speech, we create an `Audio.Speech` request structure as follows\n\n```elixir\nspeech_req =\n  Audio.Speech.new(\n    model: \"tts-1\",\n    voice: \"alloy\",\n    input: \"The quick brown fox jumped over the lazy dog\",\n    response_format: \"mp3\"\n  )\n```\n\nWe then call the [`Audio.Speech.create()`](https://platform.openai.com/docs/api-reference/audio/createSpeech) function to create the audio response\n\n```elixir\n{:ok, speech_response} = openai |> Audio.Speech.create(speech_req)\n```\n\nWe can play the response using the `Kino` Audio widget.\n\n```elixir\nspeech_response |> Kino.Audio.new(:mp3)\n```","ref":"userguide.html#create-speech"},{"type":"extras","title":"Create transcription - OpenaiEx User Guide","doc":"To define an audio transcription request structure, we need to create a file parameter using `Audio.File.new()`.\n\n```elixir\n# if you're having problems downloading raw github content, you may need to manually set your DNS server to \"8.8.8.8\" (google)\naudio_url = \"https://raw.githubusercontent.com/restlessronin/openai_ex/main/assets/transcribe.mp3\"\naudio_file = OpenaiEx.new_file(name: audio_url, content: fetch_blob.(audio_url))\n\n# audio_file = OpenaiEx.new_file(path: Path.join(__DIR__, \"../assets/transcribe.mp3\"))\n```\n\nThe file parameter is used to create the Audio.Transcription request structure\n\n```elixir\ntranscription_req = Audio.Transcription.new(file: audio_file, model: \"whisper-1\")\n```\n\nWe then call the [`Audio.Transcription.create()`](https://platform.openai.com/docs/api-reference/audio/createTranscription) function to create a transcription.\n\n```elixir\n{:ok, transcription_response} = openai |> Audio.Transcription.create(transcription_req)\n```","ref":"userguide.html#create-transcription"},{"type":"extras","title":"Create translation - OpenaiEx User Guide","doc":"The translation call uses practically the same request structure, but calls the [`Audio.Translation.create()`](https://platform.openai.com/docs/api-reference/audio/createTranslation) endpoint\n\nFor more information on the audio endpoints see the [Openai API Audio Reference](https://platform.openai.com/docs/api-reference/audio)","ref":"userguide.html#create-translation"},{"type":"extras","title":"File - OpenaiEx User Guide","doc":"","ref":"userguide.html#file"},{"type":"extras","title":"List files - OpenaiEx User Guide","doc":"To request all files that belong to the user organization, call the [`File.list()`](https://platform.openai.com/docs/api-reference/files/list) function\n\n```elixir\nalias OpenaiEx.Files\n\nopenai |> Files.list()\n```","ref":"userguide.html#list-files"},{"type":"extras","title":"Upload files - OpenaiEx User Guide","doc":"To upload a file, we need to create a file parameter, and then the upload request\n\n```elixir\n# if you're having problems downloading raw github content, you may need to manually set your DNS server to \"8.8.8.8\" (google)\nftf_url = \"https://raw.githubusercontent.com/restlessronin/openai_ex/main/assets/fine-tune.jsonl\"\nfine_tune_file = OpenaiEx.new_file(name: ftf_url, content: fetch_blob.(ftf_url))\n\n# fine_tune_file = OpenaiEx.new_file(path: Path.join(__DIR__, \"../assets/fine-tune.jsonl\"))\n\nupload_req = Files.new_upload(file: fine_tune_file, purpose: \"fine-tune\")\n```\n\nThen we call the [`File.create()`](https://platform.openai.com/docs/api-reference/files/upload) function to upload the file\n\n```elixir\n{:ok, upload_res} = openai |> Files.create(upload_req)\n```\n\nWe can verify that the file has been uploaded by calling\n\n```elixir\nopenai |> Files.list()\n```\n\nWe grab the file id from the previous response value to use in the following samples\n\n```elixir\nfile_id = upload_res[\"id\"]\n```","ref":"userguide.html#upload-files"},{"type":"extras","title":"Retrieve files - OpenaiEx User Guide","doc":"In order to retrieve meta information on a file, we simply call the [`File.retrieve()`]() function with the given id\n\n```elixir\nopenai |> Files.retrieve(file_id)\n```","ref":"userguide.html#retrieve-files"},{"type":"extras","title":"Retrieve file content - OpenaiEx User Guide","doc":"Similarly to download the file contents, we call [`File.content()`]()\n\n```elixir\nopenai |> Files.content(file_id)\n```","ref":"userguide.html#retrieve-file-content"},{"type":"extras","title":"Delete file - OpenaiEx User Guide","doc":"Finally, we can delete the file by calling [`File.delete()`](https://platform.openai.com/docs/api-reference/files/delete)\n\n```elixir\nopenai |> Files.delete(file_id)\n```\n\nVerify that the file has been deleted by listing files again\n\n```elixir\nopenai |> Files.list()\n```","ref":"userguide.html#delete-file"},{"type":"extras","title":"FineTuning Job - OpenaiEx User Guide","doc":"To run a fine-tuning job, we minimally need a training file. We will re-run the file creation request above.\n\n```elixir\n{:ok,  upload_res} = openai |> Files.create(upload_req)\n```\n\nNext we call `FineTuning.Jobs.new()` to create a new request structure\n\n```elixir\nalias OpenaiEx.FineTuning\n\nft_req = FineTuning.Jobs.new(model: \"gpt-4o-mini-2024-07-18\", training_file: upload_res[\"id\"])\n```\n\nTo begin the fine tune, we call the [`FineTuning.Jobs.create()`](https://platform.openai.com/docs/api-reference/fine-tunes/create) function\n\n```elixir\n{:ok, ft_res} = openai |> FineTuning.Jobs.create(ft_req)\n```\n\nWe can list all fine tunes by calling [`FineTuning.Jobs.list()`](https://platform.openai.com/docs/api-reference/fine-tunes/list)\n\n```elixir\nopenai |> FineTuning.Jobs.list()\n```\n\nThe function [`FineTune.retrieve()`](https://platform.openai.com/docs/api-reference/fine-tunes/retrieve) gets the details of a particular fine tune.\n\n```elixir\nft_id = ft_res[\"id\"]\nopenai |> FineTuning.Jobs.retrieve(fine_tuning_job_id: ft_id)\n```\n\nand [`FineTuning.Jobs.list_events()`](https://platform.openai.com/docs/api-reference/fine-tunes/events) can be called to get the events\n\n```elixir\nopenai |> FineTuning.Jobs.list_events(fine_tuning_job_id: ft_id)\n```\n\nTo cancel a Fine Tune job, call [`FineTuning.Jobs.cancel()`](https://platform.openai.com/docs/api-reference/fine-tunes/cancel)\n\n```elixir\nopenai |> FineTuning.Jobs.cancel(fine_tuning_job_id: ft_id)\n```\n\nA fine tuned model can be deleted by calling the [`Model.delete()`](https://platform.openai.com/docs/api-reference/fine-tunes/delete-model)\n\n```elixir\nft_model = ft_res[\"fine_tuned_model\"]\n\nunless is_nil(ft_model) do\n  openai |> Models.delete(ft_model)\nend\n```\n\nFor more information on the fine tune endpoints see the [Openai API Moderation Reference](https://platform.openai.com/docs/api-reference/fine-tunes)","ref":"userguide.html#finetuning-job"},{"type":"extras","title":"Batch - OpenaiEx User Guide","doc":"```elixir\nalias OpenaiEx.Batches\n```","ref":"userguide.html#batch"},{"type":"extras","title":"Create batch - OpenaiEx User Guide","doc":"Use the [`Batch.create()`](https://platform.openai.com/docs/api-reference/batches/createBatch) function to create and execute a batch from an uploaded file of requests.\n\nFirst, we need to upload a file containing the batch requests using the `File` API.\n\n```elixir\nbatch_url =\n  \"https://raw.githubusercontent.com/restlessronin/openai_ex/main/assets/batch-requests.jsonl\"\n\nbatch_file = OpenaiEx.new_file(name: batch_url, content: fetch_blob.(batch_url))\n\n# batch_file = OpenaiEx.new_file(path: Path.join(__DIR__, \"../assets/batch-requests.jsonl\"))\nbatch_upload_req = Files.new_upload(file: batch_file, purpose: \"batch\")\n{:ok, batch_upload_res} = openai |> Files.create(batch_upload_req)\n```\n\nThen, we create the batch request using `Batch.new()` and specify the necessary parameters.\n\n```elixir\nbatch_req =\n  Batches.new(\n    input_file_id: batch_upload_res[\"id\"],\n    endpoint: \"/v1/chat/completions\",\n    completion_window: \"24h\"\n  )\n```\n\nFinally, we call the [`Batch.create()`](https://platform.openai.com/docs/api-reference/batch/create) function to create and execute the batch.\n\n```elixir\n{:ok, batch} = openai |> Batches.create(batch_req)\n```","ref":"userguide.html#create-batch"},{"type":"extras","title":"Retrieve batch - OpenaiEx User Guide","doc":"Use the [`Batch.retrieve()`](https://platform.openai.com/docs/api-reference/batch/retrieve) function to retrieve information about a specific batch.\n\n```elixir\nbatch_id = batch[\"id\"]\n{:ok, batch_job} = openai |> Batches.retrieve(batch_id: batch_id)\n```\n\n```elixir\nbatch_job_output_file_id = batch_job[\"output_file_id\"]\n{:ok, batch_job_output_file} = openai |> Files.retrieve(batch_job_output_file_id)\n```\n\n```elixir\n{status, batch_result} = batch_output_content = openai |> Files.content(batch_job_output_file[\"id\"])\n```\n\nNote that the string is not valid json (it's a sequence of json objects without the commas or the array '[' ']' delimiters), so it cannot be parsed as such.\n\n<!-- livebook:{\"break_markdown\":true} -->","ref":"userguide.html#retrieve-batch"},{"type":"extras","title":"Cancel batch - OpenaiEx User Guide","doc":"Use the [`Batch.cancel()`](https://platform.openai.com/docs/api-reference/batch/cancel) function to cancel an in-progress batch.\n\n```elixir\n{status, cancel_result} = openai |> Batches.cancel(batch_id: batch_id)\n```","ref":"userguide.html#cancel-batch"},{"type":"extras","title":"List batches - OpenaiEx User Guide","doc":"Use the [`Batch.list()`](https://platform.openai.com/docs/api-reference/batch/list) function to list your organization's batches.\n\n```elixir\nopenai |> Batches.list()\n```\n\nFor more information on the Batch API, see the [OpenAI API Batch Reference](https://platform.openai.com/docs/api-reference/batch).","ref":"userguide.html#list-batches"},{"type":"extras","title":"Moderation - OpenaiEx User Guide","doc":"We use the moderation API by calling `Moderation.new()` to create a new request\n\n```elixir\nalias OpenaiEx.Moderations\n\nmod_req = Moderations.new(input: \"I want to kill people\")\n```\n\nThe call the function [`Moderation.create()`](https://platform.openai.com/docs/api-reference/moderations/create)\n\n```elixir\nmod_res = openai |> Moderations.create(mod_req)\n```\n\nFor more information on the moderation endpoints see the [Openai API Moderation Reference](https://platform.openai.com/docs/api-reference/moderations)","ref":"userguide.html#moderation"},{"type":"extras","title":"Assistant - OpenaiEx User Guide","doc":"```elixir\nalias OpenaiEx.Beta.Assistants\n```","ref":"userguide.html#assistant"},{"type":"extras","title":"Create Assistant - OpenaiEx User Guide","doc":"To create an assistant with model and instructions, call the [`Assistant.create()`](https://platform.openai.com/docs/api-reference/assistants/createAssistant) function.\n\nFirst, we setup the create request parameters. This request sets up an Assistant with a code interpreter tool.\n\n```elixir\nhr_assistant_req =\n  Assistants.new(\n    instructions:\n      \"You are an HR bot, and you have access to files to answer employee questions about company policies.\",\n    name: \"HR Helper\",\n    tools: [%{type: \"file_search\"}],\n    model: \"gpt-4o-mini\"\n  )\n```\n\nThen we call the create function\n\n```elixir\n{:ok, asst} = openai |> Assistants.create(hr_assistant_req)\n```","ref":"userguide.html#create-assistant"},{"type":"extras","title":"Retrieve Assistant - OpenaiEx User Guide","doc":"Extract the id field for the assistant\n\n```elixir\nassistant_id = asst[\"id\"]\n```\n\nwhich can then be used to retrieve the Assistant fields, using the [`Assistant.retrieve()`](https://platform.openai.com/docs/api-reference/assistants/getAssistant) function.\n\n```elixir\nopenai |> Assistants.retrieve(assistant_id)\n```","ref":"userguide.html#retrieve-assistant"},{"type":"extras","title":"Modify Assistant - OpenaiEx User Guide","doc":"Once created, an assistant can be modified using the [`Assistant.update()`](https://platform.openai.com/docs/api-reference/assistants/modifyAssistant) function.\n\nNow we will show an example assistant request using the retrieval tool with a set of files. First we set up the files (in this case a sample HR document) by uploading using the `File` API.\n\n```elixir\nalias OpenaiEx.Files\n\n# hr_file = OpenaiEx.new_file(path: Path.join(__DIR__, \"../assets/cyberdyne.txt\"))\nhrf_url = \"https://raw.githubusercontent.com/restlessronin/openai_ex/main/assets/cyberdyne.txt\"\nhr_file = OpenaiEx.new_file(name: hrf_url, content: fetch_blob.(hrf_url))\n\nhr_upload_req = Files.new_upload(file: hr_file, purpose: \"assistants\")\n{:ok, hr_upload_res} = openai |> Files.create(hr_upload_req)\n```\n\n```elixir\nfile_id = hr_upload_res[\"id\"]\n```\n\nNext we create the update request\n\n```elixir\nmath_assistant_req =\n  Assistants.new(\n    instructions:\n      \"You are a personal math tutor. When asked a question, write and run Python code to answer the question.\",\n    name: \"Math Tutor\",\n    tools: [%{type: \"code_interpreter\"}],\n    model: \"gpt-4o-mini\",\n    tool_resources: %{code_interpreter: %{file_ids: [file_id]}}\n  )\n```\n\nFinally we call the endpoint to modify the `Assistant`\n\n```elixir\n{:ok, asst} = openai |> Assistants.update(assistant_id, math_assistant_req)\n```","ref":"userguide.html#modify-assistant"},{"type":"extras","title":"Delete Assistant - OpenaiEx User Guide","doc":"Finally we can delete assistants using the [`Assistant.delete()`](https://platform.openai.com/docs/api-reference/assistants/deleteAssistant) function\n\n```elixir\nopenai |> Assistants.delete(assistant_id)\n```","ref":"userguide.html#delete-assistant"},{"type":"extras","title":"List Assistants - OpenaiEx User Guide","doc":"We use [`Assistant.list()`](https://platform.openai.com/docs/api-reference/assistants/listAssistants) to get a list of assistants\n\n```elixir\nassts = openai |> Assistants.list()\n```","ref":"userguide.html#list-assistants"},{"type":"extras","title":"Vector Stores - OpenaiEx User Guide","doc":"```elixir\nalias OpenaiEx.Beta.VectorStores\nalias OpenaiEx.Beta.VectorStores.Files\nalias OpenaiEx.Beta.VectorStores.File.Batches\n```","ref":"userguide.html#vector-stores"},{"type":"extras","title":"Create vector store - OpenaiEx User Guide","doc":"Use [`VectorStores.create()`](https://platform.openai.com/docs/api-reference/vector-stores/create) to create a vector store.\n\n```elixir\nvector_store_req = VectorStores.new(name: \"HR Documents\")\n{:ok, vector_store} = openai |> VectorStores.create(vector_store_req)\nvector_store_id = vector_store[\"id\"]\n```","ref":"userguide.html#create-vector-store"},{"type":"extras","title":"Retrieve vector store - OpenaiEx User Guide","doc":"Use [`VectorStores.retrieve()`](https://platform.openai.com/docs/api-reference/vector-stores/retrieve) to retrieve a vector store.\n\n```elixir\nopenai |> VectorStores.retrieve(vector_store_id)\n```","ref":"userguide.html#retrieve-vector-store"},{"type":"extras","title":"Update vector store - OpenaiEx User Guide","doc":"Use [`VectorStores.update()`](https://platform.openai.com/docs/api-reference/vector-stores/modify) to modify the vector store.\n\n```elixir\nopenai |> VectorStores.update(vector_store_id, %{name: \"HR Documents 2\"})\n```","ref":"userguide.html#update-vector-store"},{"type":"extras","title":"Delete vector store - OpenaiEx User Guide","doc":"[`VectorStores.delete()`](https://platform.openai.com/docs/api-reference/vector-stores/delete) can be used to delete a vector store.\n\n```elixir\nopenai |> VectorStores.delete(vector_store_id)\n```","ref":"userguide.html#delete-vector-store"},{"type":"extras","title":"List vector stores - OpenaiEx User Guide","doc":"We use [`VectorStores.list()`](https://platform.openai.com/docs/api-reference/vector-stores/list) to get a list of vectorstores.\n\n```elixir\nopenai |> VectorStores.list()\n```","ref":"userguide.html#list-vector-stores"},{"type":"extras","title":"Vector Store Files - OpenaiEx User Guide","doc":"","ref":"userguide.html#vector-store-files"},{"type":"extras","title":"Create vector store file - OpenaiEx User Guide","doc":"We can create a vector store file by attaching a file to a vector store using [`VectorStores.Files.create()`](https://platform.openai.com/docs/api-reference/vector-stores-files/createFile).\n\nFirst we recreate the vector store above\n\n```elixir\n{:ok, vector_store} = openai |> VectorStores.create(VectorStores.new(name: \"HR Documents\"))\n```\n\nthen attach the file id from earlier\n\n```elixir\nvector_store_id = vector_store[\"id\"]\n{:ok, vs_file} = openai |> VectorStores.Files.create(vector_store_id, file_id)\n```","ref":"userguide.html#create-vector-store-file"},{"type":"extras","title":"Retrieve vector store file - OpenaiEx User Guide","doc":"Retrieve a vector store file using the [`VectorStores.Files.retrieve()`](https://platform.openai.com/docs/api-reference/vector-stores-files/getFile) function\n\n```elixir\nopenai |> VectorStores.Files.retrieve(vector_store_id, file_id)\n```","ref":"userguide.html#retrieve-vector-store-file"},{"type":"extras","title":"Delete vector store file - OpenaiEx User Guide","doc":"Detach a file from the vector store using [`VectorStores.Files.delete()`](https://platform.openai.com/docs/api-reference/vector-stores-files/deleteFile)\n\n```elixir\nopenai |> VectorStores.Files.delete(vector_store_id, file_id)\n```","ref":"userguide.html#delete-vector-store-file"},{"type":"extras","title":"List vector store files - OpenaiEx User Guide","doc":"List vector store files using [`VectorStores.Files.list()`](https://platform.openai.com/docs/api-reference/vector-stores-files/listFiles)\n\n```elixir\nopenai |> VectorStores.Files.list(vector_store_id)\n```","ref":"userguide.html#list-vector-store-files"},{"type":"extras","title":"Vector Store File Batches - OpenaiEx User Guide","doc":"File batches allow addition of multiple files to a vector store in a single operation.","ref":"userguide.html#vector-store-file-batches"},{"type":"extras","title":"Create VS file batch - OpenaiEx User Guide","doc":"Use [`VectorStores.File.Batch.create()`](https://platform.openai.com/docs/api-reference/vector-stores-file-batches/createBatch) to attach a list of file ids to a vector store.\n\n```elixir\n{:ok, vsf_batch} = openai |> VectorStores.File.Batches.create(vector_store_id, [file_id])\n```","ref":"userguide.html#create-vs-file-batch"},{"type":"extras","title":"Retrieve VS file batch - OpenaiEx User Guide","doc":"Use [`VectorStores.File.Batch.retrieve()`](https://platform.openai.com/docs/api-reference/vector-stores-file-batches/getBatch) to retrieve the batch.\n\n```elixir\nvsf_batch_id = vsf_batch[\"id\"]\nopenai |> VectorStores.File.Batches.retrieve(vector_store_id, vsf_batch_id)\n```","ref":"userguide.html#retrieve-vs-file-batch"},{"type":"extras","title":"Cancel VS file batch - OpenaiEx User Guide","doc":"Use [`VectorStores.File.Batches.cancel()`](https://platform.openai.com/docs/api-reference/vector-stores-file-batches/cancelBatch) to cancel a batch.\n\n```elixir\nopenai |> VectorStores.File.Batches.cancel(vector_store_id, vsf_batch_id)\n```","ref":"userguide.html#cancel-vs-file-batch"},{"type":"extras","title":"List VS file batch - OpenaiEx User Guide","doc":"Use [`VectorStores.File.Batches.list()`](https://platform.openai.com/docs/api-reference/vector-stores-file-batches/listBatchFiles)\n\n```elixir\nopenai |> VectorStores.File.Batches.list(vector_store_id, vsf_batch_id)\n```","ref":"userguide.html#list-vs-file-batch"},{"type":"extras","title":"Thread - OpenaiEx User Guide","doc":"```elixir\nalias OpenaiEx.Beta.Threads\nalias OpenaiEx.Beta.Threads.Messages\n```","ref":"userguide.html#thread"},{"type":"extras","title":"Create thread - OpenaiEx User Guide","doc":"Use the [`Thread.create()`] function to create threads. A thread can be created empty or with messages.\n\n```elixir\n{:ok, empty_thread} = openai |> Threads.create()\n\nmsg_hr =\n  Messages.new(\n    role: \"user\",\n    content: \"What company do we work at?\",\n    attachments: [%{file_id: file_id, tools: [%{type: \"file_search\"}]}]\n  )\n\nmsg_ai = Messages.new(role: \"user\", content: \"How does AI work? Explain it in simple terms.\")\n\nthrd_req = Threads.new(messages: [msg_hr, msg_ai])\n\n{:ok, thread} = openai |> Threads.create(thrd_req)\n```","ref":"userguide.html#create-thread"},{"type":"extras","title":"Retrieve thread - OpenaiEx User Guide","doc":"[`Thread.retrieve()`](https://platform.openai.com/docs/api-reference/threads/getThread) can be used to get the thread parameters given the id.\n\n```elixir\nthread_id = thread[\"id\"]\nopenai |> Threads.retrieve(thread_id)\n```","ref":"userguide.html#retrieve-thread"},{"type":"extras","title":"Modify thread - OpenaiEx User Guide","doc":"The metadata for a thread can be modified using [`Thread.update()`](https://platform.openai.com/docs/api-reference/threads/modifyThread)\n\n```elixir\nopenai |> Threads.update(thread_id, %{metadata: %{modified: \"true\", user: \"abc123\"}})\n```","ref":"userguide.html#modify-thread"},{"type":"extras","title":"Delete thread - OpenaiEx User Guide","doc":"Use [`Thread.delete()`](https://platform.openai.com/docs/api-reference/threads/deleteThread) to delete a thread\n\n```elixir\nopenai |> Threads.delete(thread_id)\n```\n\nVerify deletion\n\n```elixir\nopenai |> Threads.retrieve(thread_id)\n```","ref":"userguide.html#delete-thread"},{"type":"extras","title":"Messages - OpenaiEx User Guide","doc":"","ref":"userguide.html#messages"},{"type":"extras","title":"Create message - OpenaiEx User Guide","doc":"You can create a single message for a thread using [`Message.create()`](https://platform.openai.com/docs/api-reference/messages/createMessage)\n\n```elixir\nthread_id = empty_thread[\"id\"]\n\n{:ok, message} = openai |> Threads.Messages.create(thread_id, msg_hr)\n```","ref":"userguide.html#create-message"},{"type":"extras","title":"Retrieve message - OpenaiEx User Guide","doc":"Use [`Message.retrieve()`] to retrieve a message\n\n```elixir\nmessage_id = message[\"id\"]\nopenai |> Threads.Messages.retrieve(%{thread_id: thread_id, message_id: message_id})\n```","ref":"userguide.html#retrieve-message"},{"type":"extras","title":"Modify message - OpenaiEx User Guide","doc":"The metadata for a message can be modified by [`Message.update()`]\n\n```elixir\nmetadata = %{modified: \"true\", user: \"abc123\"}\n\nupd_msg_req =\n  Threads.Messages.new(thread_id: thread_id, message_id: message_id, metadata: metadata)\n\n{:ok, message} = openai |> Threads.Messages.update(upd_msg_req)\n```","ref":"userguide.html#modify-message"},{"type":"extras","title":"List messages - OpenaiEx User Guide","doc":"Use [`Message.list()`] to get all the messages for a given thread\n\n```elixir\nopenai |> Threads.Messages.list(thread_id)\n```","ref":"userguide.html#list-messages"},{"type":"extras","title":"Runs - OpenaiEx User Guide","doc":"```elixir\nalias OpenaiEx.Beta.Threads.Runs\n```","ref":"userguide.html#runs"},{"type":"extras","title":"Create run - OpenaiEx User Guide","doc":"A run represents an execution on a thread. Use to [`Run.create()`](https://platform.openai.com/docs/api-reference/runs/createRun) with an assistant on a thread\n\n```elixir\n{:ok, math_assistant} = openai |> Assistants.create(math_assistant_req)\nmath_assistant_id = math_assistant[\"id\"]\n\nrun_req = Runs.new(thread_id: thread_id, assistant_id: math_assistant_id)\n\n{:ok, run} = openai |> Runs.create(run_req)\n```\n\n#### Streaming\n\nIt is possible to stream the result of executing a run or resuming a run after submitting tool outputs. To accomplish this, pass `stream: true` to the `create`, `create_thread_and_run` and `submit_tool_outputs` functions.\n\n```elixir\n{:ok, run_stream} = openai |> Runs.create(run_req, stream: true)\nIO.puts(inspect(run_stream))\nIO.puts(inspect(run_stream.task_pid))\nrun_stream.body_stream |> Stream.flat_map(& &1) |> Enum.each(fn x -> IO.puts(inspect(x)) end)\n```","ref":"userguide.html#create-run"},{"type":"extras","title":"Retrieve run - OpenaiEx User Guide","doc":"Retrieve a run using [`Run.retrieve()`](https://platform.openai.com/docs/api-reference/runs/getRun)\n\n```elixir\nrun_id = run[\"id\"]\nopenai |> Runs.retrieve(%{thread_id: thread_id, run_id: run_id})\n```","ref":"userguide.html#retrieve-run"},{"type":"extras","title":"Modify run - OpenaiEx User Guide","doc":"The run metadata can be modified using the [`Run.update()`](https://platform.openai.com/docs/api-reference/runs/modifyRun) function\n\n```elixir\nopenai\n|> Runs.update(%{\n  thread_id: thread_id,\n  run_id: run_id,\n  metadata: %{user_id: \"user_zmVY6FvuBDDwIqM4KgH\"}\n})\n```","ref":"userguide.html#modify-run"},{"type":"extras","title":"List runs - OpenaiEx User Guide","doc":"List the runs belonging to a thread using [`Run.list()`](https://platform.openai.com/docs/api-reference/runs/listRuns)\n\n```elixir\n# Basic usage\nopenai |> Runs.list([\n  thread_id: thread_id\n])\n\n# With optional parameters\nopenai |> Runs.list([\n  thread_id: thread_id,\n  limit: 10, \n  order: \"desc\", \n  include: [\"run_steps\"]\n])\n```","ref":"userguide.html#list-runs"},{"type":"extras","title":"Submit tool outputs to a run - OpenaiEx User Guide","doc":"When a run has the `status`: \"requires_action\" and `required_action.type` is `submit_tool_outputs`, the [`Run.submit_tool_outputs()`](https://platform.openai.com/docs/api-reference/runs/submitToolOutputs) can be used to submit the outputs from the tool calls once they're all completed. All outputs must be submitted in a single request.\n\n```elixir\nopenai\n|> Runs.submit_tool_outputs(%{\n  thread_id: thread_id,\n  run_id: run_id,\n  tool_outputs: [%{tool_call_id: \"foobar\", output: \"28C\"}]\n})\n```","ref":"userguide.html#submit-tool-outputs-to-a-run"},{"type":"extras","title":"Cancel a run - OpenaiEx User Guide","doc":"You can cancel a run `in_progress` using [`Run.cancel()`](https://platform.openai.com/docs/api-reference/runs/cancelRun)\n\n```elixir\nopenai |> Runs.cancel(%{thread_id: thread_id, run_id: run_id})\n```","ref":"userguide.html#cancel-a-run"},{"type":"extras","title":"Create thread and run - OpenaiEx User Guide","doc":"Use [`Run.create_and_run()`](https://platform.openai.com/docs/api-reference/runs/createThreadAndRun) to create a thread and run.\n\n```elixir\n\n```\n\n<!-- livebook:{\"offset\":52921,\"stamp\":{\"token\":\"XCP.V272Gaja0IOMEhLDHwXpdFURtiYVhw7Ke_yn77aZMPGGdDlMaPFsOOLjArBArJs7t1u0AfN5CX0usNZgt8_7VcUsiDMB387yVZbY6SoZM6TpP2q-cfqO2MQ\",\"version\":2}} -->","ref":"userguide.html#create-thread-and-run"},{"type":"extras","title":"Streaming Orderbot","doc":"# Streaming Orderbot\n\n```elixir\nMix.install([\n  {:openai_ex, \"~> 0.9.8\"},\n  {:kino, \"~> 0.15.3\"}\n])\n\nalias OpenaiEx\nalias OpenaiEx.Chat\nalias OpenaiEx.ChatMessage\n```","ref":"streaming_orderbot.html"},{"type":"extras","title":"Setup - Streaming Orderbot","doc":"This notebook creates an Orderbot, similar to the one in [Deeplearning.AI Orderbot](https://hexdocs.pm/openai_ex/dlai_orderbot.html), but using the streaming version of the Chat Completion API.\n\n```elixir\nopenai = System.fetch_env!(\"LB_OPENAI_API_KEY\") |> OpenaiEx.new()\n```\n\n```elixir\n# We need to make the request task pid available to the cancel button by sharing state\n{:ok, pid} = Agent.start_link(fn -> nil end, name: :shared_task_pid)\n```\n\n```elixir\ndefmodule OpenaiEx.Notebooks.StreamingOrderbot do\n  alias OpenaiEx\n  require Logger\n\n  def set_task_pid(task_pid) do\n    Agent.update(:shared_task_pid, fn _ -> task_pid end)\n  end\n\n  def get_task_pid do\n    Agent.get(:shared_task_pid, fn pid -> pid end)\n  end\n\n  def create_chat_req(args = [_ | _]) do\n    args\n    |> Enum.into(%{\n      model: \"gpt-4o-mini\",\n      temperature: 0\n    })\n    |> Chat.Completions.new()\n  end\n\n  def get_stream(openai = %OpenaiEx{}, messages) do\n    openai |> Chat.Completions.create!(create_chat_req(messages: messages), stream: true)\n  end\n\n  def stream_to_completions(%{body_stream: body_stream}) do\n    body_stream\n    |> Stream.flat_map(& &1)\n    |> Stream.map(fn %{data: d} -> d |> Map.get(\"choices\") |> List.first() |> Map.get(\"delta\") end)\n    |> Stream.filter(fn map -> map |> Map.has_key?(\"content\") end)\n    |> Stream.map(fn map -> map |> Map.get(\"content\") end)\n  end\n\n  def stream_completion_to_frame(stream, frame) do\n    try do\n      result =\n        stream\n        |> stream_to_completions()\n        |> Enum.reduce(\"\", fn token, text ->\n          next = text <> token\n          Kino.Frame.render(frame, Kino.Text.new(next))\n          next\n        end)\n\n      {:ok, result}\n    rescue\n      e in OpenaiEx.Error ->\n        case e do\n          %{kind: :sse_cancellation} ->\n            message = \"Request was canceled.\"\n            Kino.Frame.render(frame, Kino.Text.new(message))\n            {:canceled, message}\n\n          _ ->\n            message = \"An error occurred: #{e.message}\"\n            Kino.Frame.render(frame, Kino.Text.new(message))\n            {:error, message}\n        end\n    end\n  end\n\n  def create_orderbot(openai = %OpenaiEx{}, context) do\n    chat_frame = Kino.Frame.new()\n    last_frame = Kino.Frame.new()\n    inputs = [prompt: Kino.Input.textarea(\"You\")]\n    form = Kino.Control.form(inputs, submit: \"Send\", reset_on_submit: [:prompt])\n    cancel_button = Kino.Control.button(\"Cancel\")\n    Kino.Frame.render(chat_frame, Kino.Markdown.new(\"","ref":"streaming_orderbot.html#setup"},{"type":"extras","title":"Orderbot Chat\")) - Streaming Orderbot","doc":"Kino.Layout.grid([chat_frame, cancel_button, last_frame, form], boxed: true, gap: 16)\n    |> Kino.render()\n\n    stream_o = openai |> get_stream(context)\n    {status, bot_says} = stream_o |> stream_completion_to_frame(last_frame)\n\n    Kino.listen(\n      form,\n      context ++ if(status == :ok, do: [ChatMessage.assistant(bot_says)], else: []),\n      fn %{data: %{prompt: you_say}}, history ->\n        Kino.Frame.render(last_frame, Kino.Text.new(\"\"))\n        Kino.Frame.append(chat_frame, Kino.Text.new(List.last(history).content))\n        Kino.Frame.append(chat_frame, Kino.Markdown.new(\"**You** #{you_say}\"))\n\n        stream = openai |> get_stream(history ++ [ChatMessage.user(you_say)])\n        set_task_pid(stream.task_pid)\n        {status, bot_says} = stream |> stream_completion_to_frame(last_frame)\n\n        case status do\n          :ok -> {:cont, history ++ [ChatMessage.user(you_say), ChatMessage.assistant(bot_says)]}\n          _ -> {:cont, history}\n        end\n      end\n    )\n\n    Kino.listen(\n      cancel_button,\n      fn _event ->\n        pid = get_task_pid()\n        OpenaiEx.HttpSse.cancel_request(pid)\n      end\n    )\n  end\nend\n\nalias OpenaiEx.Notebooks.StreamingOrderbot\n```","ref":"streaming_orderbot.html#orderbot-chat"},{"type":"extras","title":"Orderbot - Streaming Orderbot","doc":"```elixir\ncontext = [\n  ChatMessage.system(\"\"\"\n  You are OrderBot, an automated service to collect orders for a pizza restaurant. \\\n  You first greet the customer, then collects the order, \\\n  and then asks if it's a pickup or delivery. \\\n  You wait to collect the entire order, then summarize it and check for a final \\\n  time if the customer wants to add anything else. \\\n  If it's a delivery, you ask for an address. \\\n  Finally you collect the payment.\\\n  Make sure to clarify all options, extras and sizes to uniquely \\\n  identify the item from the menu.\\\n  You respond in a short, very conversational friendly style. \\\n  The menu includes \\\n  pepperoni pizza  12.95, 10.00, 7.00 \\\n  cheese pizza   10.95, 9.25, 6.50 \\\n  eggplant pizza   11.95, 9.75, 6.75 \\\n  fries 4.50, 3.50 \\\n  greek salad 7.25 \\\n  Toppings: \\\n  extra cheese 2.00, \\\n  mushrooms 1.50 \\\n  sausage 3.00 \\\n  canadian bacon 3.50 \\\n  AI sauce 1.50 \\\n  peppers 1.00 \\\n  Drinks: \\\n  coke 3.00, 2.00, 1.00 \\\n  sprite 3.00, 2.00, 1.00 \\\n  bottled water 5.00 \\\n  \"\"\")\n]\n```\n\n```elixir\nopenai |> StreamingOrderbot.create_orderbot(context)\n```","ref":"streaming_orderbot.html#orderbot"},{"type":"extras","title":"Deeplearning.AI Order Bot","doc":"# Deeplearning.AI Order Bot\n\n```elixir\nMix.install([\n  {:openai_ex, \"~> 0.9.8\"},\n  {:kino, \"~> 0.15.3\"}\n])\n\nalias OpenaiEx\nalias OpenaiEx.Chat\nalias OpenaiEx.ChatMessage\n```","ref":"dlai_orderbot.html"},{"type":"extras","title":"Source - Deeplearning.AI Order Bot","doc":"This notebook is an elixir translation of the python notebook in [Lesson 8](https://learn.deeplearning.ai/chatgpt-prompt-eng/lesson/8/chatbot), of [Deeplearning.AI](https://www.deeplearning.ai/)'s course [ChatGPT Prompt Engineering for Developers](https://www.deeplearning.ai/short-courses/chatgpt-prompt-engineering-for-developers/).","ref":"dlai_orderbot.html#source"},{"type":"extras","title":"Chat Format - Deeplearning.AI Order Bot","doc":"In this notebook, you will explore how you can utilize the chat format to have extended conversations with chatbots personalized or specialized for specific tasks or behaviors.","ref":"dlai_orderbot.html#chat-format"},{"type":"extras","title":"Setup - Deeplearning.AI Order Bot","doc":"```elixir\nopenai =\n  System.fetch_env!(\"LB_OPENAI_API_KEY\")\n  |> OpenaiEx.new()\n\n# uncomment the line at the end of this block comment when working with a local LLM with a \n# proxy such as llama.cpp-python in the example below, our development livebook server is \n# running in a docker dev container while the local llm is running on the host machine\n# |> OpenaiEx.with_base_url(\"http://host.docker.internal:8000/v1\")\n```\n\n```elixir\ndefmodule OpenaiEx.Notebooks.DlaiOrderbot do\n  alias OpenaiEx\n  alias OpenaiEx.Chat\n\n  def create_chat_req(args = [_ | _]) do\n    args\n    |> Enum.into(%{\n      model: \"gpt-4o-mini\",\n      temperature: 0\n    })\n    |> Chat.Completions.new()\n  end\n\n  def get_completion(openai = %OpenaiEx{}, cc_req = %{}) do\n    openai\n    |> Chat.Completions.create!(cc_req)\n    # for debugging\n    #    |> IO.inspect()\n    |> Map.get(\"choices\")\n    |> List.first()\n    |> Map.get(\"message\")\n    |> Map.get(\"content\")\n  end\nend\n\nalias OpenaiEx.Notebooks.DlaiOrderbot\n```\n\n```elixir\nmessages = [\n  ChatMessage.system(\"You are an assistant that speaks like Shakespeare.\"),\n  ChatMessage.user(\"tell me a joke\"),\n  ChatMessage.assistant(\"Why did the chicken cross the road\"),\n  ChatMessage.user(\"I don't know\")\n]\n\nreq = DlaiOrderbot.create_chat_req(messages: messages, temperature: 1)\nopenai |> DlaiOrderbot.get_completion(req)\n```\n\n```elixir\nmessages = [\n  ChatMessage.system(\"You are friendly chatbot.\"),\n  ChatMessage.user(\"Hi, my name is Isa\")\n]\n\nreq = DlaiOrderbot.create_chat_req(messages: messages, temperature: 1)\nopenai |> DlaiOrderbot.get_completion(req)\n```\n\n```elixir\nmessages = [\n  ChatMessage.system(\"You are friendly chatbot.\"),\n  ChatMessage.user(\"Yes, can you remind me, What is my name?\")\n]\n\nreq = DlaiOrderbot.create_chat_req(messages: messages, temperature: 1)\nopenai |> DlaiOrderbot.get_completion(req)\n```\n\n```elixir\nmessages = [\n  ChatMessage.system(\"You are friendly chatbot.\"),\n  ChatMessage.user(\"Hi, my name is Isa\"),\n  ChatMessage.assistant(\n    \"Hi Isa! It's nice to meet you. Is there anything I can help you with today?\"\n  ),\n  ChatMessage.user(\"Yes, can you remind me, What is my name?\")\n]\n\nreq = DlaiOrderbot.create_chat_req(messages: messages, temperature: 1)\nopenai |> DlaiOrderbot.get_completion(req)\n```","ref":"dlai_orderbot.html#setup"},{"type":"extras","title":"Order Bot - Deeplearning.AI Order Bot","doc":"We can automate the collection of user prompts and assistant responses to build a OrderBot. The OrderBot will take orders at a pizza restaurant.\n\n```elixir\ncontext = [\n  ChatMessage.system(\"\"\"\n  You are OrderBot, an automated service to collect orders for a pizza restaurant. \\\n  You first greet the customer, then collects the order, \\\n  and then asks if it's a pickup or delivery. \\\n  You wait to collect the entire order, then summarize it and check for a final \\\n  time if the customer wants to add anything else. \\\n  If it's a delivery, you ask for an address. \\\n  Finally you collect the payment.\\\n  Make sure to clarify all options, extras and sizes to uniquely \\\n  identify the item from the menu.\\\n  You respond in a short, very conversational friendly style. \\\n  The menu includes \\\n  pepperoni pizza  12.95, 10.00, 7.00 \\\n  cheese pizza   10.95, 9.25, 6.50 \\\n  eggplant pizza   11.95, 9.75, 6.75 \\\n  fries 4.50, 3.50 \\\n  greek salad 7.25 \\\n  Toppings: \\\n  extra cheese 2.00, \\\n  mushrooms 1.50 \\\n  sausage 3.00 \\\n  canadian bacon 3.50 \\\n  AI sauce 1.50 \\\n  peppers 1.00 \\\n  Drinks: \\\n  coke 3.00, 2.00, 1.00 \\\n  sprite 3.00, 2.00, 1.00 \\\n  bottled water 5.00 \\\n  \"\"\")\n]\n```\n\n```elixir\nappend_completion = fn openai, messages, frame ->\n  req = DlaiOrderbot.create_chat_req(messages: messages)\n  bot_says = openai |> DlaiOrderbot.get_completion(req)\n  Kino.Frame.append(frame, Kino.Text.new(\"#{bot_says}\"))\n  bot_says\nend\n\nchat_frame = Kino.Frame.new()\ninputs = [prompt: Kino.Input.textarea(\"You\")]\nform = Kino.Control.form(inputs, submit: \"Send\", reset_on_submit: [:prompt])\nKino.Frame.render(chat_frame, Kino.Markdown.new(\"","ref":"dlai_orderbot.html#order-bot"},{"type":"extras","title":"Orderbot Chat\")) - Deeplearning.AI Order Bot","doc":"Kino.Layout.grid([chat_frame, form], boxed: true, gap: 16) |> Kino.render()\n\nbot_says = openai |> append_completion.(context, chat_frame)\n\nKino.listen(\n  form,\n  context ++ [ChatMessage.assistant(bot_says)],\n  fn %{data: %{prompt: you_say}}, history ->\n    Kino.Frame.append(chat_frame, Kino.Markdown.new(\"**You** #{you_say}\"))\n\n    bot_says = openai |> append_completion.(history ++ [ChatMessage.user(you_say)], chat_frame)\n\n    {:cont, history ++ [ChatMessage.user(you_say), ChatMessage.assistant(bot_says)]}\n  end\n)\n```","ref":"dlai_orderbot.html#orderbot-chat"},{"type":"extras","title":"Image Generation Kino App","doc":"<!-- livebook:{\"app_settings\":{\"access_type\":\"public\",\"slug\":\"genimage\"}} -->\n\n# Image Generation Kino App\n\n```elixir\nMix.install([\n  {:openai_ex, \"~> 0.9.8\"},\n  {:kino, \"~> 0.15.3\"}\n])\n\nalias OpenaiEx\nalias OpenaiEx.Images\n```","ref":"images.html"},{"type":"extras","title":"Simple Kino UI - Image Generation Kino App","doc":"```elixir\nopenai = System.fetch_env!(\"LB_OPENAI_API_KEY\") |> OpenaiEx.new()\n```\n\nset default parameters for image generation, and define a function to fetch generated images from a URL.\n\n```elixir\nsize = \"256x256\"\nn = 4\n\nfetch_blob = fn url ->\n  Finch.build(:get, url) |> Finch.request!(OpenaiEx.Finch) |> Map.get(:body)\nend\n```","ref":"images.html#simple-kino-ui"},{"type":"extras","title":"Prompt / Response UI - Image Generation Kino App","doc":"```elixir\ntext_input = Kino.Input.textarea(\"Describe Image\")\n\nform = Kino.Control.form([text: text_input], submit: \"Generate\")\nframe = Kino.Frame.new()\n\nKino.listen(form, fn %{data: %{text: prompt}} ->\n  Kino.Frame.render(frame, Kino.Text.new(\"Running...\"))\n\n  res_urls =\n    openai\n    |> Images.generate!(%{\n      prompt: prompt,\n      n: n,\n      size: size\n    })\n    #   |> IO.inspect()\n    |> Map.get(\"data\")\n    |> Enum.map(fn x -> x[\"url\"] end)\n\n  res_urls\n  |> Enum.map(fn x -> x |> fetch_blob.() |> Kino.Image.new(\"image/png\") end)\n  |> Kino.Layout.grid(columns: 2)\n  |> then(&Kino.Frame.render(frame, &1))\nend)\n\nKino.Layout.grid([form, frame], boxed: true, gap: 16)\n```","ref":"images.html#prompt-response-ui"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}